SystemOrganization addCategory: #'GreenNeon-HTML'!
SystemOrganization addCategory: #'GreenNeon-HTML-Tags'!
SystemOrganization addCategory: #'GreenNeon-Document'!
SystemOrganization addCategory: #'GreenNeon-Core'!
SystemOrganization addCategory: #'GreenNeon-Head'!
SystemOrganization addCategory: #'GreenNeon-Examples'!

!String methodsFor: '*greenneon-javascript' stamp: 'chc 4/12/2012 11:10'!
javascriptOn: aStream
	JSStream encode: self to: aStream! !

!BlockClosure methodsFor: '*greenneon' stamp: 'chc 8/17/2010 16:07'!
renderOn: aRenderer
	self numArgs = 0 
		ifTrue: [self value]
		ifFalse: [self value: aRenderer]
! !

!BlockContext methodsFor: '*greenneon' stamp: 'chc 8/17/2010 11:56'!
renderOn: aRenderer
	self numArgs = 0 
		ifTrue: [self value]
		ifFalse: [self value: aRenderer]
! !

Object subclass: #GNHtmlEncoder
	instanceVariableNames: 'attributeBuffer'
	classVariableNames: 'HtmlCharacters'
	poolDictionaries: ''
	category: 'GreenNeon-Document'!

!GNHtmlEncoder commentStamp: 'chc 10/23/2011 11:24' prior: 0!
I ensure that the numbers that represent letters in Squeak are changed a bit to produce Html a browser will understand.!

!GNHtmlEncoder class methodsFor: 'encoding' stamp: 'lr 6/14/2006 08:00'!
encode: anObject
	^ String streamContents: [ :stream | self encode: anObject to: stream ]! !

!GNHtmlEncoder class methodsFor: 'encoding' stamp: 'chc 1/11/2011 15:32'!
encode: anObject to: aStream
	| charOrString |
	anObject displayString do: [:char |
		charOrString := HtmlCharacters 
			at: char asInteger + 1 
			ifAbsent: [ char asCharacter ].
		charOrString isString
			ifTrue: [ aStream nextPutAll: charOrString ]
			ifFalse: [ aStream nextPut: charOrString ] ]! !

!GNHtmlEncoder class methodsFor: 'initialization' stamp: 'chc 10/12/2011 10:38'!
initialize
	"WAHtmlBuilder initialize"
	HtmlCharacters _ Array new: 256.
	
	0 to: 255 do: [:ea | HtmlCharacters at: ea + 1 put: ea asCharacter].
	
	#($" 'quot' $< 'lt' $& 'amp' $> 'gt') pairsDo:
		[:c :s | HtmlCharacters at: (c asInteger + 1) put: ('&',s,';') ]
	! !

Object subclass: #HVHttpView
	instanceVariableNames: 'model'
	classVariableNames: 'HtmlEntities SafeChars UltraSafeChars'
	poolDictionaries: ''
	category: 'GreenNeon-Core'!

!HVHttpView commentStamp: 'chc 10/23/2011 12:12' prior: 0!
HVHttpView
	HVRootView
		GNAdaptor
	HVTransientView
	

This is the key hierarchy of GreenNeon and is from HttpView2 (which is why they start with HV). HVRootView processes requests with the #process: selector. Well, it used to, when HttpView2 used the Komanche server. I subclassed HVRootView with GNAdaptor to create an adaptor change the server to WebClient. In GNAdaptor>>#process: you can see a request comes in, it looks for a view/webpage (the model can be nil, so that you are connecting to no database and only making web pages), sends that view class the method #default (#dispatch devolves to #default), collects whatever that method filled the #c instance variable with (which represents aWARenderCanvas) and then sends it back out again with #asWebResponseTo: There use to be a selector called #asKomResponseTo: and I changed it for WebClient.

All web pages are in classes that are subclasses of HVTransientView.!

!HVHttpView class methodsFor: 'defaults' stamp: 'chc 5/18/2011 16:48'!
createModel
	"This is called when a HVRootView is created
	and no model has been specified.
	Default model is nil, override in subclass."

	^SMSqueakMap default! !

!HVHttpView class methodsFor: 'defaults' stamp: 'gk 10/24/2003 10:43'!
defaultAlias
	"This is called when a HVRootView is created
	and no alias has been specified.
	Default alias, override in subclass."

	^''! !

!HVHttpView class methodsFor: 'defaults' stamp: 'gk 12/4/2003 13:39'!
defaultPort
	"This is called when a HVRootView is created
	and no port number has been specified.
	Default alias, override in subclass."

	^8080! !

!HVHttpView class methodsFor: 'defaults' stamp: 'gk 11/13/2003 23:31'!
defaultViewClass
	"This is called when a HVRootView is created
	and no viewClass has been specified.
	Default alias, override in subclass."

	^self! !

!HVHttpView class methodsFor: 'instance creation' stamp: 'gk 11/4/2004 13:04'!
on: aModel
	"Create a new view on a model.
	We set the model before initializeing so that it
	can use the model."

	^super basicNew model: aModel; initialize; yourself! !

!HVHttpView class methodsFor: 'start-stop' stamp: 'chc 7/23/2012 13:00'!
rootView
	"Return class to use as root view. Override to provide your own.
	Default is the generic HVRootView."

	^GNAdaptor

	"^HVRootView"
	
	! !

!HVHttpView class methodsFor: 'start-stop' stamp: 'gk 11/6/2003 14:06'!
start
	"Start service on default port in deployment mode."

	^self startOn: self defaultPort mode: #deployment! !

!HVHttpView class methodsFor: 'start-stop' stamp: 'chc 5/25/2011 10:27'!
startOn: portNum 
	
	^(self rootView
		model: self createModel
		alias: self defaultAlias
		viewClass: self defaultViewClass)
		startOn: portNum; yourself! !

!HVHttpView class methodsFor: 'defaults' stamp: 'gk 11/6/2003 14:51'!
useSessions
	"By default we don't."

	^false! !

!HVHttpView methodsFor: 'html' stamp: 'gk 3/31/2005 14:43'!
fixForHtml: string
	^HVHttpView escapeForHtml: string! !

!HVHttpView methodsFor: 'initialize-release' stamp: 'gk 12/19/2003 13:31'!
initialize
	"Do nothing."! !

!HVHttpView methodsFor: 'accessing' stamp: 'gk 10/24/2003 10:26'!
model
	^model! !

!HVHttpView methodsFor: 'accessing' stamp: 'gk 10/24/2003 10:26'!
model: aModel
	model _ aModel! !

!HVHttpView methodsFor: 'responses' stamp: 'gk 4/11/2007 10:05'!
notFound: url
	"Make a not found response."

	HVResponseNotification signal:
		(HttpService current errorResponseStatus: #notFound description: url)! !

!HVHttpView methodsFor: 'responses' stamp: 'gk 3/4/2004 14:31'!
redirectTo: url
	"Make a redirection to another url."

	HVResponseNotification signal:
		(HttpResponse redirectTo: (url isEmpty ifTrue:['/'] ifFalse: [url]))! !

!HVHttpView methodsFor: 'responses' stamp: 'gk 3/4/2004 14:31'!
redirectToDefault
	"Make a redirection to the default url of this view."

	^self redirectTo: self defaultUrl! !

!HVHttpView methodsFor: 'responses' stamp: 'gk 10/12/2005 15:56'!
redirectToLocal: page
	"Make a redirection to another page in this view,
	equaling another method in this class."

	^self redirectTo: (self originalUrlFor: page)! !

HVHttpView subclass: #HVRootView
	instanceVariableNames: 'viewClass coreMod sessionMod alias selectorFilter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-Core'!

HVRootView subclass: #GNAdaptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-Core'!

!GNAdaptor methodsFor: 'as yet unclassified' stamp: 'chc 2/24/2012 12:11'!
process: request


	| view |
	view := viewClass on: model parent: self.
	view request: request. 

	^(view dispatch) asWebResponseTo: request
		! !

!GNAdaptor methodsFor: 'as yet unclassified' stamp: 'chc 7/23/2012 13:03'!
startOn: aPort 
	|x|
	"(WebServer reset default)
		listenOn: aPort."
	x := WebServer new. 
	x listenOn: aPort.
	x addService: '/' action: [:req| self process: req. ].

	! !

!HVRootView class methodsFor: 'instance creation' stamp: 'gk 10/24/2003 09:08'!
alias: anAlias
	"This relies on model being set in initialize."

	^self model: nil alias: anAlias viewClass: nil! !

!HVRootView class methodsFor: 'instance creation' stamp: 'gk 10/24/2003 09:08'!
model: aModel
	"Create a persistent root view that can be plugged into Komanche."

	^self model: aModel alias: nil viewClass: nil! !

!HVRootView class methodsFor: 'instance creation' stamp: 'gk 10/24/2003 09:07'!
model: aModel alias: anAlias
	"Create a persistent root view that can be plugged into Komanche."

	^self model: aModel alias: anAlias viewClass: nil! !

!HVRootView class methodsFor: 'instance creation' stamp: 'gk 12/9/2003 16:10'!
model: aModel alias: anAlias viewClass: aViewClass
	"Create a persistent root view that can be plugged into Komanche."

	^(super on: aModel) alias: anAlias viewClass: aViewClass! !

!HVRootView class methodsFor: 'instance creation' stamp: 'gk 11/4/2004 13:05'!
new
	"This relies on that at least model and viewClass
	is set in initialize. Note: in later Squeaks this
	method is superfluous, but it makes it work in
	old Squeaks too."

	^super basicNew initialize! !

!HVRootView class methodsFor: 'defaults' stamp: 'gk 3/3/2004 11:55'!
rootView
	"Return class to use as root view. Override to provide your own.
	Default is self."

	^self! !

!HVRootView methodsFor: 'initalize-release' stamp: 'gk 3/25/2004 16:11'!
alias: anAlias viewClass: aClass
	"Set the default alias and viewClass if not already set."

	alias ifNil: [alias _ anAlias].
	viewClass ifNil: [viewClass _ aClass]
! !

!HVRootView methodsFor: 'dispatch' stamp: 'gk 4/2/2004 11:21'!
allowedSelector: aSelector forView: aView
	"Answer true if <aSelector> is ok to call from a URL
	to the view <aView>. Default implementation is to
	use the pluggable filter block."

	^selectorFilter copy value: aSelector value: aView! !

!HVRootView methodsFor: 'dispatch' stamp: 'gk 12/19/2003 13:48'!
allowedSrcSelector: aSelector forView: aView
	"Answer true if it is ok to view the source
	of <aSelector> in the view <aView>.
	Default implementation is the same as for execution."

	^self allowedSelector: aSelector forView: aView! !

!HVRootView methodsFor: 'initalize-release' stamp: 'gk 3/4/2004 15:15'!
categoryOfElement: selector inClassOrSuperclass: class
	"Find first category of selector up the superclass chain."

	^class ifNotNil: [
		^(class organization categoryOfElement: selector)
			ifNil: [self categoryOfElement: selector inClassOrSuperclass: class superclass]]! !

!HVRootView methodsFor: 'initalize-release' stamp: 'gk 3/4/2004 15:12'!
defaultSelectorFilter
	"Override this method to supply your own selectorFilter.
	Or plug it in using #selectorFilter:"

	^[:selector :view |
		(view respondsTo: selector) and: [
			(self categoryOfElement: selector inClassOrSuperclass: view class) = #urls]]! !

!HVRootView methodsFor: 'comanche' stamp: 'chc 2/22/2011 13:22'!
getTopView
	"Default way of instantiating a top view for the model.
	If the viewClass is set we use that, otherwise we try
	a double dispatch on the model using #viewFor:."

	^viewClass
		ifNotNil: [viewClass on: model parent: self]
		"ifNil: [(model respondsTo: #viewFor:)
				ifTrue: [model viewFor: self]
				ifFalse: [self error: 'Do not know which view to instantiate!!']]"! !

!HVRootView methodsFor: 'comanche' stamp: 'gk 3/4/2004 14:13'!
getTopView: request
	"Default way of instantiating a top view for the model.
	If the viewClass is set we use that, otherwise we try
	a double dispatch on the model using #viewFor:."

	^viewClass
		ifNotNil: [viewClass on: model parent: self]
		ifNil: [(model respondsTo: #viewFor:)
				ifTrue: [model viewFor: self]
				ifFalse: [self error: 'Do not know which view to instantiate!!']]! !

!HVRootView methodsFor: 'comanche' stamp: 'chc 2/22/2011 13:31'!
getViewClass
	"Default way of instantiating a top view for the model.
	If the viewClass is set we use that, otherwise we try
	a double dispatch on the model using #viewFor:."

	^"viewClass
		ifNotNil: ["viewClass on: model parent: self"]"
		"ifNil: [(model respondsTo: #viewFor:)
				ifTrue: [model viewFor: self]
				ifFalse: [self error: 'Do not know which view to instantiate!!']]"! !

!HVRootView methodsFor: 'initalize-release' stamp: 'gk 3/3/2004 12:31'!
initialize
	"Default selector filter is to verify that
	the view responds to the selector and that
	it is in the method category 'urls'."

	alias _ ''.
	selectorFilter _ self defaultSelectorFilter! !

!HVRootView methodsFor: 'views' stamp: 'gk 12/10/2003 10:24'!
parentsDo: aBlock
	"Don't have a parent, do nothing."
! !

!HVRootView methodsFor: 'views' stamp: 'gk 12/10/2003 10:25'!
parentsDoReverse: aBlock
	"Have no parent, do nothing."! !

!HVRootView methodsFor: 'accessing' stamp: 'chc 7/12/2012 12:11'!
process: request
	"Process the request. This is the method that is called by Comanche.
	Given the view we stick the request into it and let it take over.
	When the result is returned we turn it into a proper HttpResponse.
	A special notification can be signaled to return a specific response and
	bypassing the call chain."

	| view w |
	(request url endsWith: '/favicon.ico') ifTrue: [
		^HttpResponse fromString: 'favicon.ico not supported'].
	view := self getTopView: request.
	view request: request. "normally not needed when using #viewFor: but here it is"
	w := view dispatch. 
	Transcript show: w.
	"["^(w context document stream contents) asHttpResponseTo: request"]
		on: HVResponseNotification do: [:ex | ^ex response]"
! !

!HVRootView methodsFor: 'private' stamp: 'gk 12/19/2003 00:07'!
request
	"I am the root view and do not hold the request
	because I need to be Process safe."

	^nil! !

!HVRootView methodsFor: 'accessing' stamp: 'gc 8/1/2007 12:58'!
response
	^ nil! !

!HVRootView methodsFor: 'views' stamp: 'gk 11/6/2003 17:26'!
rootView
	"Return the view at the root, that's me."

	^self! !

!HVRootView methodsFor: 'accessing' stamp: 'gk 12/19/2003 13:30'!
selectorFilter
	"Return the filter used in #allowedSelector:forView:"

	^selectorFilter! !

!HVRootView methodsFor: 'accessing' stamp: 'gk 12/19/2003 13:30'!
selectorFilter: aBlock
	"Set the filter used in #allowedSelector:forView:.
	It should implement #value:value: with
	the selector and the view instance as arguments."

	selectorFilter _ aBlock! !

!HVRootView methodsFor: 'defaults' stamp: 'gk 3/4/2004 14:20'!
serviceName
	"By default we use class name of the HVRootView subclass,
	otherwise the class name of viewClass if we have one."

	^(viewClass notNil and: [self class = HVRootView])
		ifTrue: [viewClass name]
		ifFalse: [self class name]! !

!HVRootView methodsFor: 'comanche' stamp: 'gk 4/7/2005 23:11'!
sessionTimedOut: session
	"Delegate if implemented."
	
	(model respondsTo: #sessionTimedOut:) ifTrue:[ model sessionTimedOut: session ]! !

!HVRootView methodsFor: 'comanche' stamp: 'gk 11/6/2003 17:18'!
sessionsDo: aBlock
	"Iterate over sessions. Only works if we have turned sessions on,
	check implementors of #useSessions."

	^sessionMod sessionsDo: aBlock
! !

!HVRootView methodsFor: 'start-stop' stamp: 'gk 11/6/2003 14:13'!
start
	"Start service on default port in deployment mode."

	^self startOn: self class defaultPort mode: #deployment! !

!HVRootView methodsFor: 'start-stop' stamp: 'gk 11/6/2003 14:13'!
startOn: portNum
	"Start service on port <portNum> in deployment mode."

	^self startOn: portNum mode: #deployment! !

!HVRootView methodsFor: 'accessing' stamp: 'chc 7/12/2012 12:12'!
startOn: portNum mode: mode
	"Creates a new standalone http service with this root view plugged in."

	|  name useSessions ma |
	name _ self serviceName.
	useSessions _ self useSessions.
	ma := ModuleAssembly core.
	coreMod _ ma currentModule.
"	ma logTo: (KomLogger on: Transcript)."
	useSessions ifTrue: [
		ma trackSessions.
		sessionMod _ ma currentModule.
		ma sessionTimeout: 30].
	alias = ''
		ifTrue: [ma addPlug: [:request | self process: request]]
		ifFalse: [ma alias: alias
					to: [ma addPlug: [:request | self process: request]]].
	^(HttpService startOn: portNum named: name)
		plug: ma rootModule; mode: mode
! !

!HVRootView methodsFor: 'start-stop' stamp: 'gk 3/3/2004 12:13'!
stop
	"Only unregisters the Comanche service,
	override to do proper things when service is stopped."

	self class stop! !

!HVRootView methodsFor: 'views' stamp: 'gk 11/6/2003 14:27'!
topView
	"I have no parent and is thus the top view."

	^self! !

!HVRootView methodsFor: 'private' stamp: 'gk 12/9/2003 16:41'!
urlStream
	"I am the root view and can not hold a urlStream
	because I need to be Process safe."

	^nil! !

!HVRootView methodsFor: 'defaults' stamp: 'gk 3/3/2004 13:03'!
useSessions
	"By default we check with viewClass if we have one,
	otherwise false."

	^viewClass ifNil: [false] ifNotNil: [viewClass useSessions]! !

HVHttpView subclass: #HVTransientView
	instanceVariableNames: 'parent urlStream urlOriginalPosition request response currentCanvas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-Core'!

HVTransientView subclass: #GNFormTest
	instanceVariableNames: 'buddy billy c'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-Examples'!

!GNFormTest methodsFor: 'accessing' stamp: 'chc 9/17/2010 14:19'!
billy
	"Answer the value of buddy"

	^ billy! !

!GNFormTest methodsFor: 'accessing' stamp: 'chc 9/17/2010 14:19'!
billy: anObject
	"Set the value of buddy"

	billy := anObject! !

!GNFormTest methodsFor: 'accessing' stamp: 'chc 8/29/2010 02:58'!
buddy
	"Answer the value of buddy"

	^ buddy! !

!GNFormTest methodsFor: 'accessing' stamp: 'chc 8/29/2010 02:58'!
buddy: anObject
	"Set the value of buddy"

	buddy := anObject! !

!GNFormTest methodsFor: 'urls' stamp: 'chc 4/4/2011 11:41'!
default

	c := self canvas. 
	c buildHead.
	c form: [ c textInput name: '1'. 
			  c textInput name: '2'; value: 'rico'.
			  c submitButton ].
	c paragraph: billy.
	c paragraph: buddy.
	^c! !

!GNFormTest methodsFor: 'as yet unclassified' stamp: 'chc 9/17/2010 21:37'!
initialize 

	billy := buddy := ''.! !

!GNFormTest methodsFor: 'accessing' stamp: 'chc 9/17/2010 21:38'!
processForm

	billy := c nameField: '1'.
      buddy := c nameField: '2'! !

!GNFormTest methodsFor: 'as yet unclassified' stamp: 'chc 4/6/2011 20:21'!
title

	^'Greetings Earthling'! !

HVTransientView subclass: #GNHelloWorld
	instanceVariableNames: 'data c'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-Examples'!

!GNHelloWorld methodsFor: 'urls' stamp: 'chc 11/12/2012 12:43'!
default

	c := self canvas.
	c buildHead.

	c p: 'Hello World !!'.
		
	^c! !

!GNHelloWorld methodsFor: 'all' stamp: 'chc 4/6/2011 20:18'!
style

	^'body {background-color: lightblue;}'! !

!GNHelloWorld methodsFor: 'all' stamp: 'chc 4/6/2011 20:18'!
title

	^'Greetings Earthling'! !

!HVTransientView class methodsFor: 'defaults' stamp: 'chc 7/26/2011 11:35'!
canvasClass
	
	| context document  |
	
	document := WAHtmlStreamDocument new. 
	context := WARenderingContext new document: document.
	^WARenderCanvas context: context callbacks: nil
	
	"Seaside callbacks can be added back in. For now we leave them be nil"! !

!HVTransientView class methodsFor: 'instance creation' stamp: 'gk 10/24/2003 10:32'!
on: aModel parent: aParent
	"Create a new view on a model and with aParent as parent view.
	This is normally done on the fly for each request."

	^(super on: aModel) initializeWith: aParent; yourself! !

!HVTransientView methodsFor: 'dispatching' stamp: 'gk 12/19/2003 13:27'!
allowedSelector: aSelector
	"Answer true if <aSelector> is ok to call from a URL.
	Default implementation is to delegate to the rootView
	which represents this web application."

	^self rootView allowedSelector: aSelector forView: self ! !

!HVTransientView methodsFor: 'dispatching' stamp: 'gk 12/19/2003 13:55'!
allowedSrcSelector: aSelector
	"Answer true if it is ok to view the source for
	<aSelector> from a URL.
	Default implementation is to delegate to the rootView
	which represents this web application."

	^self rootView allowedSrcSelector: aSelector forView: self ! !

!HVTransientView methodsFor: 'utilities' stamp: 'gk 3/26/2004 15:54'!
attributeAt: key ifAbsent: block
	^KomSession current attributes at: key ifAbsent: block! !

!HVTransientView methodsFor: 'utilities' stamp: 'gk 3/26/2004 15:55'!
attributeAt: key put: value
	^KomSession current attributes at: key put: value! !

!HVTransientView methodsFor: 'dispatching' stamp: 'gk 10/20/2005 01:47'!
baseUrl
	"This is the original path of the urlStream."

	^self originalUrl! !

!HVTransientView methodsFor: 'html creation' stamp: 'chc 9/4/2010 15:22'!
canvas
	"Create a standard canvas (newer low level render framework)."

	currentCanvas := self class canvasClass. 
	currentCanvas context request: request.
	currentCanvas view: self.
	^ currentCanvas! !

!HVTransientView methodsFor: 'dispatching' stamp: 'chc 6/27/2011 10:56'!
currentMethod
	"Pick out the next method (path part = directory) from the urlStream."

	^urlStream! !

!HVTransientView methodsFor: 'dispatching' stamp: 'gk 10/12/2005 01:34'!
defaultUrl
	"Return a url String representing this view's
	original position within the url of the request
	with #default appended."

	^self originalUrlFor: #default! !

!HVTransientView methodsFor: 'dispatching' stamp: 'chc 7/12/2011 13:54'!
dispatch

	| x |

	x := self nextMethod.
	^self dispatchOn: x.! !

!HVTransientView methodsFor: 'dispatching' stamp: 'chc 7/14/2011 12:31'!
dispatchOn: method 

	| m |

	method isEmptyOrNil ifTrue:[ ^self default ].

	m _ method asSymbol.

	^self perform: m.


	
! !

!HVTransientView methodsFor: 'utilities' stamp: 'gc 8/1/2007 12:27'!
handleUpload: aBlock 
	| fileName stream |
	request isPostMultipart 
		ifTrue: 
			[request multipartFormFieldsDo: 
					[:chunk | 
					chunk fileName isEmptyOrNil 
						ifFalse: 
							[fileName := (chunk fileName findTokens: ':/\') last.
							stream := aBlock value: fileName.
							stream ifNotNil: [[chunk saveToStream: stream] ensure: [stream close]]]]]! !

!HVTransientView methodsFor: 'initialize-release' stamp: 'chc 11/27/2010 18:06'!
initialize
	super initialize.
	"title _ 'No title set'.
	response := HttpResponse new."! !

!HVTransientView methodsFor: 'initialize-release' stamp: 'chc 8/20/2010 15:39'!
initializeWith: aParent 
	aParent ifNotNil: 
			[parent := aParent.
			request ifNil: 
					[request := parent request.
					urlStream := parent urlStream.
					urlStream ifNotNil: [urlOriginalPosition := urlStream position]].
			aParent response ifNotNil: [response := aParent response]].
	self postInitialize! !

!HVTransientView methodsFor: 'urls' stamp: 'gk 3/4/2004 14:33'!
logout
	"By default we logout the account and redirect to the default page."

	self logoutAccount; redirectToDefault! !

!HVTransientView methodsFor: 'dispatching' stamp: 'gk 12/10/2003 11:05'!
nextMethod
	"Pick out the next method (path part = directory) from the urlStream."

	^urlStream next! !

!HVTransientView methodsFor: 'dispatching' stamp: 'gc 7/31/2007 11:39'!
originalUrl
	"Return a url String representing this view's
	original position within the url of the request."

	| curPos result |
	curPos _ urlStream position.
	urlStream position: urlOriginalPosition.
	result _ urlStream path.
	urlStream position: curPos.
	^result! !

!HVTransientView methodsFor: 'dispatching' stamp: 'gk 10/11/2005 23:00'!
originalUrlFor: stringOrSymbol
	"Return a url String representing this view's
	original position within the url of the request
	with <stringOrSymbol> appended."

	| curPos result |
	curPos _ urlStream position.
	urlStream position: urlOriginalPosition.
	result _ urlStream pathWith: stringOrSymbol.
	urlStream position: curPos.
	^result! !

!HVTransientView methodsFor: 'accessing' stamp: 'gk 12/10/2003 10:21'!
parent
	"Return my parent view."

	^parent! !

!HVTransientView methodsFor: 'parent views' stamp: 'gk 12/10/2003 10:23'!
parentsDo: aBlock
	"Iterate over the parent views my parent first."

	aBlock value: parent.
	parent parentsDo: aBlock! !

!HVTransientView methodsFor: 'parent views' stamp: 'gk 12/10/2003 10:25'!
parentsDoReverse: aBlock
	"Iterate over the parent views root view first."

	parent parentsDoReverse: aBlock.
	aBlock value: parent! !

!HVTransientView methodsFor: 'dispatching' stamp: 'gk 3/2/2004 17:28'!
peekNextMethod
	"Pick out the next method (path part = directory) from the urlStream."

	^urlStream peek! !

!HVTransientView methodsFor: 'initialize-release' stamp: 'gh 9/20/2002 14:31'!
postInitialize
! !

!HVTransientView methodsFor: 'responses' stamp: 'gc 8/1/2007 12:27'!
redirectToReferer
	"Redirect to referer URL. This has problems with IE
	since it sends referer in a barfed partially unescaped iso encoding."

	^ self redirectTo: request referer! !

!HVTransientView methodsFor: 'dispatching' stamp: 'gc 8/1/2007 12:27'!
reload
	"Make a redirection to same url."

	^ HttpResponse redirectTo: request rawUrl! !

!HVTransientView methodsFor: 'dispatching' stamp: 'gk 6/20/2005 10:38'!
reload: url
	"Make a redirection but adjust the URL.
	Base implementation does nothing."

	^self redirectTo: url! !

!HVTransientView methodsFor: 'dispatching' stamp: 'gk 6/9/2005 16:00'!
reloadWithoutLast
	"Make a redirection to same url without last
	path element, with parameters stripped and
	ending with a slash."

	^self redirectTo: ((urlStream setToEnd; back; path) utf8ToIso isoToSqueak)! !

!HVTransientView methodsFor: 'dispatching' stamp: 'gk 4/22/2005 12:44'!
reloadWithoutParameters
	"Make a redirection to same url with parameters stripped."

	^self redirectTo: urlStream fullPath! !

!HVTransientView methodsFor: 'dispatching' stamp: 'chc 2/3/2011 18:27'!
rendererClass
	^WARenderCanvas! !

!HVTransientView methodsFor: 'accessing' stamp: 'gc 8/1/2007 12:27'!
request
	^ request! !

!HVTransientView methodsFor: 'initialize-release' stamp: 'chc 1/25/2011 13:16'!
request: aRequest 
	request := aRequest.
	request ifNotNil: 
			[urlStream := HVUrlStream onString: request rawUrl.
			urlStream ifNotNil: [urlOriginalPosition := urlStream position]]! !

!HVTransientView methodsFor: 'accessing' stamp: 'gc 8/1/2007 12:43'!
response
	^ response! !

!HVTransientView methodsFor: 'parent views' stamp: 'gk 12/10/2003 10:22'!
rootView
	"Return the view at the root, the root view will return self."

	^parent rootView! !

!HVTransientView methodsFor: 'utilities' stamp: 'gk 3/31/2005 14:26'!
showSourceFor: selector
	"Show the source for given selector."

	| b |
	b _ self builder.
	^b start; h2: ('Source for ', self class name, '>>', selector);
		pre: ((self fixForHtml: (self class sourceMethodAt: selector) asString)
				copyReplaceAll: '_' with: ':=');
		end; yourself! !

!HVTransientView methodsFor: 'start-stop' stamp: 'gk 11/6/2003 11:59'!
start
	"Start the web app."

	self class start! !

!HVTransientView methodsFor: 'start-stop' stamp: 'gk 10/24/2003 09:14'!
stop
	"Stop service with name of class."

	self class stop! !

!HVTransientView methodsFor: 'accessing' stamp: 'gh 1/28/2002 14:58'!
title
	^title! !

!HVTransientView methodsFor: 'parent views' stamp: 'gk 11/6/2003 14:26'!
topView
	"Return the view that thinks it is a top view."

	^self isTopView
		ifTrue: [self]
		ifFalse: [parent topView]! !

!HVTransientView methodsFor: 'dispatching' stamp: 'gk 12/9/2003 16:20'!
urlFor: stringOrSymbol
	"Return a url String representing this view's
	current position within the url of the request
	with <stringOrSymbol> appended."

	^urlStream pathWith: stringOrSymbol! !

!HVTransientView methodsFor: 'dispatching' stamp: 'gk 1/18/2005 15:01'!
urlPath
	"This is the current path of the urlStream."

	^urlStream path! !

!HVTransientView methodsFor: 'parent views' stamp: 'chc 6/27/2011 10:58'!
urlStream

	^urlStream! !

!HVTransientView methodsFor: 'utilities' stamp: 'gk 3/2/2004 16:29'!
validateEmail: aString
	"Validate that <aString> conforms to at least this syntax:
		'something @ something . something'
	"

	| s at dot |
	s _ aString withBlanksTrimmed.
	at _ aString indexOf: $@.
	dot _ s indexOf: $. startingAt: at.
	((dot * at) = 0) ifTrue:[^false].
	(at > 1) & (at < dot) & (dot < s size) ifFalse:[^false].
	^true! !

!HVTransientView methodsFor: 'utilities' stamp: 'gh 5/30/2002 13:42'!
validateSafeString: aString

	aString do: [:c | (SafeChars includes: c) ifFalse:[^false]].
	^true! !

!HVTransientView methodsFor: 'utilities' stamp: 'gh 5/30/2002 13:58'!
validateUltraSafeString: aString

	aString do: [:c | (UltraSafeChars includes: c) ifFalse:[^false]].
	^true! !

Object subclass: #HVUrlStream
	instanceVariableNames: 'url stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-Core'!

!HVUrlStream commentStamp: 'gk 12/10/2003 10:12' prior: 0!
A HVUrlStream is a PositionableStream on a URL path.
We could just use a ReadStream on the path itself - but this way both the url and the stream on the path is kept together in one unit. We can also add some special behavior.
!

!HVUrlStream class methodsFor: 'instance creation' stamp: 'gk 12/9/2003 14:56'!
on: aUrl
	"Return a stream on the url."

	^self new url: aUrl! !

!HVUrlStream class methodsFor: 'instance creation' stamp: 'chc 9/20/2010 14:35'!
onString: aUrlString
	"Return a stream on the url."
	^self new url: (Url absoluteFromText: aUrlString)! !

!HVUrlStream methodsFor: 'streaming' stamp: 'gk 4/5/2004 11:39'!
back
	"Back up one step in the stream."

	stream position: ((stream position - 1) max: 1)! !

!HVUrlStream methodsFor: 'streaming' stamp: 'gk 4/7/2004 14:38'!
back: anInteger
	"Back up some steps in the stream."

	stream position: ((stream position - anInteger) max: 1)! !

!HVUrlStream methodsFor: 'urls' stamp: 'gk 5/17/2005 14:35'!
back: x with: aStringOrSymbol
	"Return a absolute url of the rest of the path
	with <aStringOrSymbol> appended, separated
	with /-characters, like this:

	/dabba/<aStringOrSymbol>"

	| part here |	
	^String streamContents: [:s |
		here _ stream position.
		self back: x.
		[stream atEnd] whileFalse: [
			part _ stream next.
			part ifNotNil: [
				s nextPut: $/; nextPutAll: part]].
		stream position: here.
		s nextPut: $/; nextPutAll: aStringOrSymbol]! !

!HVUrlStream methodsFor: 'private' stamp: 'gk 4/6/2005 15:39'!
decode: aString
	^aString ifNotNil: [aString unescapePercents utf8ToIso isoToSqueak]! !

!HVUrlStream methodsFor: 'urls' stamp: 'gk 4/7/2004 14:31'!
fullPath
	"Return an absolute url of the full path
	separated with /-characters, like this:

	/aba/dabba"

	| path |
	path _ url path.	
	^String streamContents: [:s |
		path do: [:part |
			part isEmpty ifFalse: [
				s nextPut: $/; nextPutAll: part]]]! !

!HVUrlStream methodsFor: 'streaming' stamp: 'gk 3/29/2004 11:46'!
last
	"Return the last path part.
	nil is used as a last element marker."

	^stream last! !

!HVUrlStream methodsFor: 'streaming' stamp: 'gk 1/5/2005 13:24'!
next
	"Return the next path part.
	nil is used as a last element marker."

	^self decode: stream next! !

!HVUrlStream methodsFor: 'urls' stamp: 'gk 12/10/2003 01:00'!
path
	"Return an absolute url of the current path
	separated with /-characters, like this:

	/aba/dabba"

	| path part |
	path _ url path.	
	^String streamContents: [:s |
		1 to: stream position - 1 do: [:i |
			part _ path at: i.
			part isEmpty ifFalse: [
				s nextPut: $/; nextPutAll: part]]]! !

!HVUrlStream methodsFor: 'urls' stamp: 'gk 4/13/2005 14:00'!
pathElements
	^url path! !

!HVUrlStream methodsFor: 'urls' stamp: 'gk 10/12/2005 02:42'!
pathWith: aStringOrSymbol
	"Return a absolute url of the full path
	up to the current position
	with <aStringOrSymbol> appended, separated
	with /-characters, like this:

	/aba/dabba/<aStringOrSymbol>"

	| path part |
	path _ stream contents.	
	^String streamContents: [:s |
		1 to: stream position do: [:i |
			part _ path at: i.
			part isEmptyOrNil ifFalse: [
				s nextPut: $/; nextPutAll: part]].
		s nextPut: $/; nextPutAll: aStringOrSymbol]! !

!HVUrlStream methodsFor: 'urls' stamp: 'gk 3/29/2004 11:47'!
pathWithPrefix: aStringOrSymbol
	"Return a relative url of the current path
	with <aStringOrSymbol> prepended to the current last
	path part. Path parts are separated with /-characters,
	like this:

	/aba/dabba/<aStringOrSymbol>yabba"

	| path lastPart |
	lastPart _ self last.
	lastPart ifNotNil: [
		path _ url path.	
		^String streamContents: [:s |
			1 to: stream position - 1 do: [:i |
				s nextPut: $/; nextPutAll: (path at: i)].
			s nextPut: $/; nextPutAll: aStringOrSymbol, lastPart]]! !

!HVUrlStream methodsFor: 'streaming' stamp: 'gk 1/5/2005 13:24'!
peek
	"Return the next path part without moving forward
	in the stream. nil is used as a last element marker."

	^self decode: stream peek! !

!HVUrlStream methodsFor: 'streaming' stamp: 'gk 12/9/2003 14:57'!
position

	^stream position! !

!HVUrlStream methodsFor: 'streaming' stamp: 'gk 12/9/2003 14:56'!
position: pos

	stream position: pos! !

!HVUrlStream methodsFor: 'streaming' stamp: 'gk 12/9/2003 14:57'!
reset

	^stream reset! !

!HVUrlStream methodsFor: 'urls' stamp: 'gk 5/17/2005 14:29'!
restWith: aStringOrSymbol
	"Return a absolute url of the rest of the path
	with <aStringOrSymbol> appended, separated
	with /-characters, like this:

	/dabba/<aStringOrSymbol>"

	| part here |	
	^String streamContents: [:s |
		here _ stream position.
		[stream atEnd] whileFalse: [
			part _ stream next.
			part isEmpty ifFalse: [
				s nextPut: $/; nextPutAll: part]].
		stream position: here.
		s nextPut: $/; nextPutAll: aStringOrSymbol]! !

!HVUrlStream methodsFor: 'streaming' stamp: 'gk 4/7/2004 14:37'!
setToEnd

	^stream setToEnd! !

!HVUrlStream methodsFor: 'initialize-release' stamp: 'gk 12/9/2003 15:00'!
url
	^url! !

!HVUrlStream methodsFor: 'initialize-release' stamp: 'gk 3/29/2004 11:48'!
url: aUrl

	url _ aUrl.
	stream _ ReadStream on: (aUrl path copyWith: nil)! !

!Object methodsFor: '*greenneon' stamp: 'mb 3/16/2006 10:32'!
asSeasideString
	^ self displayString
! !

!Object methodsFor: '*greenneon' stamp: 'mb 3/23/2006 07:32'!
convertSeasideString: aString
	^ aString
! !

!Object methodsFor: '*greenneon' stamp: 'chc 8/17/2010 11:51'!
displayString
	^ self asString! !

!Object methodsFor: '*greenneon' stamp: 'ab 10/1/2002 13:47'!
inspectorFields
	|members|
	members _ self class allInstVarNames
					collect: [:ivar | ivar -> (self instVarNamed: ivar)].
						
	self class isVariable ifTrue:
		[members _ members, ((1 to: self size) collect: [:i | i -> (self at: i)])].
	^ members! !

!Object methodsFor: '*greenneon' stamp: 'avi 9/1/2004 21:20'!
isIdenticalToSnapshot: anObject
	1 to: self class instSize do:
		[:i | (anObject instVarAt: i) == (self instVarAt: i) ifFalse: [^ false]].
	self class isVariable ifTrue:
		[1 to: self size do: [:i | (anObject at: i) == (self at: i) ifFalse: [^ false]]].
	^ true! !

!Object methodsFor: '*greenneon-javascript-printing' stamp: 'lr 4/20/2006 21:10'!
javascriptOn: aStream
	self printOn: aStream! !

!Object methodsFor: '*greenneon' stamp: 'avi 3/14/2005 15:19'!
labelForSelector: aSymbol
	^ aSymbol asCapitalizedPhrase! !

!Object methodsFor: '*greenneon' stamp: 'chc 8/17/2010 16:05'!
renderOn: aRenderer
	aRenderer text: self! !

!Object methodsFor: '*greenneon' stamp: 'avi 9/1/2004 21:19'!
restoreFromSnapshot: anObject
	1 to: self class instSize do: [:i | self instVarAt: i put: (anObject instVarAt: i)].
	self class isVariable ifTrue: [1 to: self size do: [:i | self at: i put: (anObject at: i)]].
! !

!Object methodsFor: '*greenneon' stamp: 'avi 9/1/2004 21:20'!
snapshotCopy
	^ self shallowCopy! !

!Object methodsFor: '*greenneon' stamp: 'mb 3/23/2006 17:53'!
validationError: message
	^WAValidationNotification raiseSignal: message
! !

Object subclass: #WABrush
	instanceVariableNames: 'parent canvas isClosed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-HTML'!

!WABrush class methodsFor: 'instance creation' stamp: 'mb 1/12/2006 18:53'!
new
	^self basicNew initialize! !

!WABrush methodsFor: 'private' stamp: 'avi 6/17/2004 12:18'!
close
	self isClosed ifFalse: [self with: []]! !

!WABrush methodsFor: 'initialize-release' stamp: 'mb 1/12/2006 18:54'!
initialize! !

!WABrush methodsFor: 'testing' stamp: 'avi 6/17/2004 12:17'!
isClosed
	^ isClosed ifNil: [false]! !

!WABrush methodsFor: 'private' stamp: 'lr 9/14/2005 22:33'!
labelForSelector: aSymbol of: anObject
	^ anObject labelForSelector: aSymbol.! !

!WABrush methodsFor: 'accessing' stamp: 'avi 6/13/2004 00:27'!
parent
	^ parent! !

!WABrush methodsFor: 'convenience' stamp: 'mb 3/23/2006 16:19'!
session
	^ WACurrentSession value! !

!WABrush methodsFor: 'initialize-release' stamp: 'avi 6/13/2004 00:27'!
setParent: aBrush canvas: aCanvas
	parent _ aBrush.
	canvas _ aCanvas! !

!WABrush methodsFor: 'public api' stamp: 'avi 6/17/2004 12:17'!
with: aBlock
	canvas nest: aBlock.
	isClosed _ true.! !

WABrush subclass: #WATagBrush
	instanceVariableNames: 'attributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-HTML'!

WATagBrush subclass: #WAAcronymTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-HTML-Tags'!

!WAAcronymTag methodsFor: 'accessing' stamp: 'mb 3/8/2006 17:36'!
tag
	^ 'acronym'! !

!WAAcronymTag methodsFor: 'attributes' stamp: 'mb 3/8/2006 17:38'!
title: aString
	self attributeAt: 'title' put: aString.! !

WATagBrush subclass: #WAAnchorTag
	instanceVariableNames: 'url isNavigation callbackKey extraParameters extraPath promptString promptDefault'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-HTML-Tags'!

!WAAnchorTag commentStamp: 'dc 7/11/2006 07:16' prior: 0!
I'm the class responsible for adding anchors (links) to your webpage. There are multiple ways of using me.


In the following case, the method #doSomethingOnClick will be sent to self when the user click on the anchor 'Click here to do something':

html anchor
  callback: [self doSomethingOnClick];
  text: 'Click here to do something'.


In fact, you are not obliged to render simple text for your anchors, a block can be executed instead:

html anchor
  callback: [self doSomethingIfUserClickMe];
  with: [put here some code to render things for the anchor text].


Following code is a shortcut to create an anchor:

html anchor
  on: #aSelector of: anObject

The text will be 'a Selector' (this is a special transformation of symbols to make them more readable)
The action will be the call of #aSelector on anObject.!

!WAAnchorTag methodsFor: 'private' stamp: 'lr 8/3/2006 13:22'!
actionUrl
	| actionUrl |
	^ callbackKey ifNotNil:
		[actionUrl := canvas context actionUrl withParameter: callbackKey.
		self isNavigation ifTrue: [actionUrl := actionUrl withParameter: '_n'].
		extraParameters ifNotNil:
			[extraParameters associationsDo: [:assoc | actionUrl addParameter: assoc key value: assoc value]]. 
		extraPath
			ifNil: [actionUrl queryString]
			ifNotNil: [actionUrl addToPath: extraPath; asString]]! !

!WAAnchorTag methodsFor: 'callbacks' stamp: 'avi 11/27/2005 16:26'!
callback: aBlock
	callbackKey _ canvas callbacks registerActionCallback: aBlock! !

!WAAnchorTag methodsFor: 'javascript' stamp: 'mb 3/8/2006 18:18'!
canHaveShortcut
	^true! !

!WAAnchorTag methodsFor: 'public api' stamp: 'avi 11/27/2005 16:36'!
extraParameters: aCollection
	extraParameters _ aCollection! !

!WAAnchorTag methodsFor: 'public api' stamp: 'avi 2/1/2006 13:08'!
extraPath: aString
	extraPath _ aString! !

!WAAnchorTag methodsFor: 'private' stamp: 'mb 3/9/2006 10:24'!
handlerForForm: formName
	#submitFormTriggeringCallback.
	^ promptString
		ifNil:
				['submitFormTriggeringCallback('
				, formName asString printString
				, ', '
				, callbackKey displayString printString
				, ', "href" ); return false;']
		ifNotNil: 
				['if(x = prompt('
				, promptString printString
				, ')) submitFormTriggeringCallback('
				, formName asString printString
				, ', '
				, callbackKey displayString printString
				, ', x); return false;']
! !

!WAAnchorTag methodsFor: 'initialize-release' stamp: 'mb 4/23/2006 15:06'!
initialize
	super initialize.
	isNavigation _ false! !

!WAAnchorTag methodsFor: 'testing' stamp: 'avi 11/27/2005 21:05'!
isNavigation
	^ isNavigation ifNil: [false]! !

!WAAnchorTag methodsFor: 'public api' stamp: 'avi 10/30/2005 00:50'!
mailto: aString
	self url: 'mailto:', aString.
	self text: aString! !

!WAAnchorTag methodsFor: 'attributes' stamp: 'avi 9/24/2005 20:50'!
name: aString
	self attributeAt: 'name' put: aString! !

!WAAnchorTag methodsFor: 'public api' stamp: 'avi 11/27/2005 16:30'!
navigation
	isNavigation _ true! !

!WAAnchorTag methodsFor: 'public api' stamp: 'avi 9/4/2005 22:10'!
newTarget
	self target: '_new'! !

!WAAnchorTag methodsFor: 'public api' stamp: 'lr 9/14/2005 23:51'!
on: aSymbol of: anObject
	self callback: [ anObject perform: aSymbol ].
	self with: (self labelForSelector: aSymbol of: anObject).! !

!WAAnchorTag methodsFor: 'events' stamp: 'mb 11/27/2005 10:27'!
onClick: aString
	super onClick: aString.
	self attributes at: 'href' ifAbsentPut: ['javascript:void(0)']
! !

!WAAnchorTag methodsFor: 'events' stamp: 'mb 3/24/2006 14:46'!
onMouseOut: aString
	super onMouseOut: aString.
	self attributes at: 'href' ifAbsentPut: ['javascript:void(0)']! !

!WAAnchorTag methodsFor: 'events' stamp: 'lr 3/13/2006 19:52'!
onMouseOver: aString 
	super onMouseOver: aString.
	self attributes at: 'href' ifAbsentPut: [ 'javascript:void(0)' ]! !

!WAAnchorTag methodsFor: 'callbacks' stamp: 'avi 3/15/2006 22:24'!
prompt: aString callback: aBlock
	self prompt: aString default: '' callback: aBlock! !

!WAAnchorTag methodsFor: 'callbacks' stamp: 'avi 3/15/2006 22:23'!
prompt: aString default: defaultString callback: aBlock
	callbackKey _ canvas callbacks registerCallback: aBlock.
	promptString _ aString.
	promptDefault _ defaultString! !

!WAAnchorTag methodsFor: 'public api' stamp: 'avi 9/11/2005 14:40'!
resourceUrl: aString
	self url: (canvas document root absoluteUrlForResource: aString)! !

!WAAnchorTag methodsFor: 'attributes' stamp: 'avi 6/22/2005 14:46'!
submitFormNamed: aString
	self onClick: (self handlerForForm: aString)! !

!WAAnchorTag methodsFor: 'accessing' stamp: 'avi 6/13/2004 00:56'!
tag
	^ 'a'! !

!WAAnchorTag methodsFor: 'attributes' stamp: 'avi 9/4/2005 22:10'!
target: aString
	self attributeAt: 'target' put: aString! !

!WAAnchorTag methodsFor: 'public api' stamp: 'ac 3/16/2005 14:28'!
text: aString
	self with: aString.! !

!WAAnchorTag methodsFor: 'attributes' stamp: 'ac 3/20/2005 01:23'!
title: aString
	self attributeAt: 'title' put: aString.! !

!WAAnchorTag methodsFor: 'unused ?' stamp: 'pmm 11/2/2005 23:52'!
toggleStringFor: aCollection
	^ String streamContents:
		[:stream |
		aCollection 
			do: [:ea |
				stream
					nextPutAll: ea displayString;
					nextPutAll: '=yes']
			separatedBy: [stream nextPutAll: ',']]! !

!WAAnchorTag methodsFor: 'public api' stamp: 'avi 11/27/2005 16:26'!
url: aString
	url _ aString! !

!WAAnchorTag methodsFor: 'public api' stamp: 'ac 2/5/2006 11:27'!
with: aBlock
	| newUrl |
	newUrl _ url ifNil: [self actionUrl].
	newUrl ifNotNil: [self attributes at: 'href' put: newUrl].
	^ super with: aBlock! !

WAAnchorTag subclass: #WAPopupAnchorTag
	instanceVariableNames: 'name extent dependent showToolbar resizable showScrollbars'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-HTML-Tags'!

!WAPopupAnchorTag methodsFor: 'public api' stamp: 'ac 7/8/2005 19:15'!
beDependent
	dependent _ true! !

!WAPopupAnchorTag methodsFor: 'public api' stamp: 'ac 9/11/2005 13:08'!
beResizable
	resizable _ true! !

!WAPopupAnchorTag methodsFor: 'accessing' stamp: 'ac 7/3/2005 16:08'!
extent: aPoint
	extent _ aPoint! !

!WAPopupAnchorTag methodsFor: 'initialize-release' stamp: 'mb 4/23/2006 15:28'!
initialize
	super initialize.
	dependent _ false.! !

!WAPopupAnchorTag methodsFor: 'testing' stamp: 'ac 7/8/2005 19:15'!
isDependent
	^ dependent ifNil: [false]! !

!WAPopupAnchorTag methodsFor: 'testing' stamp: 'ac 9/11/2005 13:07'!
isResizable
	^ resizable ifNil: [resizable _ false]! !

!WAPopupAnchorTag methodsFor: 'accessing' stamp: 'ac 7/3/2005 16:07'!
name: aString
	name _ aString! !

!WAPopupAnchorTag methodsFor: 'private' stamp: 'avi 2/2/2006 02:21'!
popupString
	^ String streamContents:
		[:stream |
		stream 
			nextPutAll: 'window.open(';
			nextPut: $';
			nextPutAll: (url ifNil: [self actionUrl]);
			nextPut: $';
			nextPut: $,;
			nextPut: $';
			nextPutAll: name;
			nextPut: $';
			nextPut:$,;
			nextPut: $';
			nextPutAll: 'width=';
			nextPutAll: extent x displayString;
			nextPutAll: ',height=';
			nextPutAll: extent y displayString;
			nextPut: $,;
			nextPutAll: self toggleString;
			nextPut: $';
			nextPutAll: ').focus()']! !

!WAPopupAnchorTag methodsFor: 'public api' stamp: 'avi 3/23/2006 22:56'!
shouldShowScrollbars
	^ showScrollbars ifNil: [showScrollbars _ false]! !

!WAPopupAnchorTag methodsFor: 'public api' stamp: 'ac 9/11/2005 13:05'!
shouldShowToolbar
	^ showToolbar ifNil: [showToolbar _ false]! !

!WAPopupAnchorTag methodsFor: 'public api' stamp: 'avi 3/23/2006 22:55'!
showScrollbars
	showScrollbars _ true! !

!WAPopupAnchorTag methodsFor: 'public api' stamp: 'ac 9/11/2005 13:04'!
showToolbar
	showToolbar _ true! !

!WAPopupAnchorTag methodsFor: 'public api' stamp: 'avi 3/23/2006 22:55'!
toggleArray
	^ Array streamContents:
		[:stream |
		self isDependent ifTrue: [stream nextPut: #dependent].
		self shouldShowToolbar ifTrue: [stream nextPut: #toolbar].
		self isResizable ifTrue: [stream nextPut: #resizable].
		self shouldShowScrollbars ifTrue: [stream nextPut: #scrollbars]]! !

!WAPopupAnchorTag methodsFor: 'public api' stamp: 'pmm 11/2/2005 23:53'!
toggleString
	^ String streamContents:
		[:stream | 
		self toggleArray 
			do: [:ea |
				stream
					nextPutAll: ea;
					nextPutAll: '=yes'] 
			separatedBy: [stream nextPutAll: ',']]! !

!WAPopupAnchorTag methodsFor: 'public api' stamp: 'ac 2/7/2006 10:50'!
with: aBlock
	self onClick: self popupString.
	self ignoreURL.
	^ super with: aBlock.! !

WATagBrush subclass: #WACanvasTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-HTML-Tags'!

!WACanvasTag methodsFor: 'attributes' stamp: 'lr 5/18/2006 08:52'!
extent: aPoint
	self width: aPoint x; height: aPoint y! !

!WACanvasTag methodsFor: 'attributes' stamp: 'lr 5/18/2006 08:51'!
height: aNumber
	self attributeAt: 'height' put: aNumber displayString! !

!WACanvasTag methodsFor: 'accessing' stamp: 'lr 5/18/2006 08:50'!
tag
	^ 'canvas'! !

!WACanvasTag methodsFor: 'attributes' stamp: 'lr 5/18/2006 08:51'!
width: aNumber
	self attributeAt: 'width' put: aNumber displayString! !

WACanvasTag subclass: #WAImageTag
	instanceVariableNames: 'url fileName mimeType document'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-HTML-Tags'!

!WAImageTag methodsFor: 'attributes' stamp: 'avi 5/10/2005 14:33'!
altText: aString
	self attributes at: 'alt' put: aString
! !

!WAImageTag methodsFor: 'attributes' stamp: 'avi 9/10/2005 18:56'!
border: aNumber
	self attributeAt: 'border' put: aNumber! !

!WAImageTag methodsFor: 'private' stamp: 'mb 6/12/2006 09:34'!
close
	url isNil ifTrue:
		[document isNil ifTrue:
			[document _ WACachedDocument fileName: fileName.
			mimeType isNil ifFalse: [document mimeType: mimeType]].
		mimeType isNil ifTrue: [mimeType _ document mimeType].
		url _ (canvas context
				urlForDocument: document
				mimeType: mimeType
				fileName: fileName)].
	self src: url.
	super close.! !

!WAImageTag methodsFor: 'accessing' stamp: 'mb 6/12/2006 08:44'!
document: anObject
	document _ anObject! !

!WAImageTag methodsFor: 'accessing' stamp: 'mb 6/12/2006 08:47'!
fileName: aString
	fileName _ aString! !

!WAImageTag methodsFor: 'public api' stamp: 'mb 6/12/2006 08:50'!
form: aForm
	self extent: aForm extent.
	self document: aForm.! !

!WAImageTag methodsFor: 'initialize-release' stamp: 'mb 8/10/2006 08:01'!
initialize
	super initialize.
	self altText: ''.! !

!WAImageTag methodsFor: 'accessing' stamp: 'mb 6/12/2006 08:47'!
mimeType: aString
	mimeType _ aString! !

!WAImageTag methodsFor: 'attributes' stamp: 'avi 9/10/2005 18:56'!
noBorder
	self border: 0! !

!WAImageTag methodsFor: 'public api' stamp: 'avi 9/11/2005 14:40'!
resourceUrl: aString
	self url: (canvas document root absoluteUrlForResource: aString)! !

!WAImageTag methodsFor: 'attributes' stamp: 'mb 6/12/2006 08:43'!
src: aString
	self attributes at: 'src' put: aString
! !

!WAImageTag methodsFor: 'accessing' stamp: 'ac 3/16/2005 12:00'!
tag
	^ 'img'! !

!WAImageTag methodsFor: 'attributes' stamp: 'mb 6/12/2006 08:45'!
url: aString
	url _ aString
! !

WATagBrush subclass: #WACollectionTag
	instanceVariableNames: 'list selected callbackBlock labelsBlock multiple'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-HTML-Tags'!

!WACollectionTag methodsFor: 'adding' stamp: 'lr 9/25/2005 11:31'!
add: anObject
	^ list add: anObject.! !

!WACollectionTag methodsFor: 'adding' stamp: 'lr 9/25/2005 11:32'!
addAll: aCollection
	^ list addAll: aCollection.! !

!WACollectionTag methodsFor: 'attributes' stamp: 'lr 9/26/2005 13:44'!
beMultiple
	multiple := true.! !

!WACollectionTag methodsFor: 'attributes' stamp: 'mb 4/23/2006 15:10'!
beSingle
	multiple _ false.! !

!WACollectionTag methodsFor: 'callbacks' stamp: 'lr 9/25/2005 11:34'!
callback: aBlock
	callbackBlock := aBlock fixTemps.! !

!WACollectionTag methodsFor: 'initialization' stamp: 'mb 4/23/2006 15:10'!
initialize
	super initialize.
	list _ OrderedCollection new.
	labelsBlock _ [ :value | value ].
	multiple _ false.
! !

!WACollectionTag methodsFor: 'testing' stamp: 'pmm 11/2/2005 22:11'!
isMultiple
	^ multiple.! !

!WACollectionTag methodsFor: 'testing' stamp: 'lr 9/26/2005 14:48'!
isSelected: anObject
	^ self isMultiple
		ifTrue: [ selected includes: anObject ]
		ifFalse: [ selected = anObject ].! !

!WACollectionTag methodsFor: 'private' stamp: 'lr 9/25/2005 11:40'!
labelForOption: anObject
	^ labelsBlock value: anObject.! !

!WACollectionTag methodsFor: 'callbacks' stamp: 'lr 9/25/2005 11:35'!
labels: aBlock
	labelsBlock := aBlock fixTemps.! !

!WACollectionTag methodsFor: 'accessing' stamp: 'lr 9/25/2005 11:34'!
list: aCollection
	self addAll: aCollection.! !

!WACollectionTag methodsFor: 'attributes' stamp: 'pmm 7/19/2006 20:10'!
on: selector of: anObject
	"copy pasted from WASelectTag, we need a traitified version of seaside"
	self selected: (anObject perform: selector).
	self callback: [ :value | anObject perform: selector asMutator with: value ].! !

!WACollectionTag methodsFor: 'accessing' stamp: 'mb 4/23/2006 18:31'!
selected: anObject
	selected _ anObject! !

WACollectionTag subclass: #WAListTag
	instanceVariableNames: 'tag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-HTML-Tags'!

!WAListTag methodsFor: 'actions' stamp: 'lr 9/25/2005 11:37'!
beOrdered
	tag := 'ol'.! !

!WAListTag methodsFor: 'actions' stamp: 'lr 9/25/2005 11:37'!
beUnordered
	tag := 'ul'.! !

!WAListTag methodsFor: 'private' stamp: 'lr 9/26/2005 15:18'!
callbackForOption: anObject
	self isMultiple 
		ifTrue: [ 
			selected := (self isSelected: anObject)
				ifTrue: [ selected copyWithout: anObject ]
				ifFalse: [ selected copyWith: anObject ].
			callbackBlock value: selected ]
		ifFalse: [ callbackBlock value: anObject ].! !

!WAListTag methodsFor: 'accessing' stamp: 'lr 9/25/2005 11:37'!
tag
	^ tag ifNil: [ 'ul' ].! !

!WAListTag methodsFor: 'public' stamp: 'lr 9/26/2005 15:17'!
with: aBlock
	super with: [
		list do: [ :each |
			canvas listItem 
				class: ((self isSelected: each)
					ifFalse: [ 'option' ]
					ifTrue: [ 'option-selected' ]);
				with: [
					callbackBlock isNil
						ifTrue: [ canvas render: (self labelForOption: each) ]
						ifFalse: [
							canvas anchor
								callback: [ self callbackForOption: each ];
								with: (self labelForOption: each) ] ] ].
		aBlock value ].! !

WACollectionTag subclass: #WASelectTag
	instanceVariableNames: 'otherLabel otherCallbackBlock isOptional promptString isSubmitOnChange optionalLabel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-HTML-Tags'!

!WASelectTag methodsFor: 'attributes' stamp: 'ac 4/13/2005 12:38'!
beOptional
	isOptional _ true! !

!WASelectTag methodsFor: 'attributes' stamp: 'ac 2/1/2006 20:23'!
beSubmitOnChange
	isSubmitOnChange _ true
! !

!WASelectTag methodsFor: 'testing' stamp: 'ac 4/13/2005 13:05'!
hasOther
	^ otherLabel notNil! !

!WASelectTag methodsFor: 'initialize-release' stamp: 'mb 4/23/2006 15:31'!
initialize
	super initialize.
	isOptional _ false.
	isSubmitOnChange _ false! !

!WASelectTag methodsFor: 'testing' stamp: 'pmm 11/2/2005 22:17'!
isOptional
	^ isOptional! !

!WASelectTag methodsFor: 'testing' stamp: 'pmm 11/2/2005 22:17'!
isSubmitOnChange
	^ isSubmitOnChange! !

!WASelectTag methodsFor: 'accessing' stamp: 'mb 1/13/2006 10:34'!
numberOfOptions
	| count |
	count _ 0.
	self isOptional ifTrue: [count _ count + 1].
	count _ count + list size.
	^ count! !

!WASelectTag methodsFor: 'attributes' stamp: 'avi 8/30/2005 13:27'!
optionalLabel: aString
	optionalLabel _ aString! !

!WASelectTag methodsFor: 'attributes' stamp: 'ac 2/1/2006 20:24'!
otherLabel: labelString otherCallback: aBlock promptString: aString
	otherLabel _ labelString.
	otherCallbackBlock _ aBlock fixTemps.
	promptString _ aString.! !

!WASelectTag methodsFor: 'attributes' stamp: 'lr 9/26/2005 09:55'!
size: anInteger
	self attributes at: 'size' put: anInteger.! !

!WASelectTag methodsFor: 'accessing' stamp: 'ac 3/17/2005 16:44'!
tag
	^ 'select'! !

WATagBrush subclass: #WACompound
	instanceVariableNames: 'callbackBlock value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-HTML-Tags'!

!WACompound methodsFor: 'callbacks' stamp: 'mb 1/30/2006 18:39'!
callback: aBlock
	callbackBlock _ aBlock
! !

!WACompound methodsFor: 'callbacks' stamp: 'pmm 7/19/2006 20:13'!
on: selector of: anObject
	"copy pasted for the third time, we really need a traitified version of seaside"
	self value: (anObject perform: selector).
	self callback: [ :date | anObject perform: selector asMutator with: date ].! !

!WACompound methodsFor: 'public api' stamp: 'mb 1/30/2006 18:40'!
value: aValue
	value := aValue! !

WACompound subclass: #WADateInput
	instanceVariableNames: 'month day year'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-HTML-Tags'!

!WADateInput methodsFor: 'public api' stamp: 'mb 7/12/2006 15:49'!
with: aBlock
	value isNil ifTrue: [value := Date today].
	canvas forgetCurrentBrush.
	(canvas select)
		id: self id;
		list: (1 to: 12);
		selected: value monthIndex;
		callback: [:m | month _ m];
		labels: [:ea | Date nameOfMonth: ea];
		close.
	canvas space.
	(canvas textInput)
		id: (self id isNil ifTrue: [nil] ifFalse: [self id , '-day']);
		value: value dayOfMonth; 
		callback: [:d | day _ [d asNumber] on: Error do: [:e | 1]];
		attributeAt: 'size' put: 2;
		attributeAt: 'maxlength' put: 2;
		close.
	canvas forgetCurrentBrush.
	canvas space.
	(canvas textInput) 
		id: (self id isNil ifTrue: [nil] ifFalse: [self id , '-year']);
		value: value year;
		callback: [:y | year _ [y asNumber] on: Error do: [:e | 1900]];
		attributeAt: 'size' put: 4;
		attributeAt: 'maxlength' put: 4;
		close.
	canvas forgetCurrentBrush.
	(canvas hiddenInput)
		callback:
			[value := Date
				newDay: (day min: (Date daysInMonth: month forYear: year))
				monthNumber: month
				year: year.
			callbackBlock value: value];
		close.
	canvas forgetCurrentBrush.
! !

WACompound subclass: #WATimeInput
	instanceVariableNames: 'withSeconds hours minutes seconds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-HTML-Tags'!

!WATimeInput methodsFor: 'initialize-release' stamp: 'mb 2/6/2006 09:56'!
initialize
	self withoutSeconds! !

!WATimeInput methodsFor: 'public api' stamp: 'mb 7/12/2006 15:50'!
with: aBlock
	value isNil ifTrue: [value := Time now].
	canvas forgetCurrentBrush.
	(canvas textInput)
		id: self id;
		value: value hour asTwoCharacterString; 
		callback: [:h | hours _ [h asNumber] on: Error do: [:e | 0]];
		attributeAt: 'size' put: 2;
		attributeAt: 'maxlength' put: 2;
		close.
	canvas forgetCurrentBrush.
	canvas space; text: ':'; space.
	(canvas textInput)
		id: (self id isNil ifTrue: [nil] ifFalse: [self id , '-mins']);
		value: value minutes asTwoCharacterString; 
		callback:[:m | minutes _ [m asNumber] on: Error do: [:e | 0]];
		attributeAt: 'size' put: 2;
		attributeAt: 'maxlength' put: 2;
		close.
	canvas forgetCurrentBrush.
	withSeconds ifTrue:
		[canvas space; text: ':'; space.
		(canvas textInput)
			id: (self id isNil ifTrue: [nil] ifFalse: [self id , '-secs']);
			value: value seconds asTwoCharacterString; 
			callback:[:s | seconds _ [s asNumber] on: Error do: [:e | 0]];
			attributeAt: 'size' put: 2;
			attributeAt: 'maxlength' put: 2;
			close.
		canvas forgetCurrentBrush]
	ifFalse:
		[seconds _ 0].
	(canvas hiddenInput)
		callback:
			[value := Time
				hour: hours
				minute: (minutes min: 59)
				second: (seconds min: 59).
			callbackBlock value: value];
		close.
	canvas forgetCurrentBrush.

! !

!WATimeInput methodsFor: 'accessing' stamp: 'mb 2/6/2006 09:55'!
withSeconds
	withSeconds _ true! !

!WATimeInput methodsFor: 'accessing' stamp: 'mb 2/6/2006 09:56'!
withoutSeconds
	withSeconds _ false! !

WATagBrush subclass: #WADivTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-HTML-Tags'!

!WADivTag methodsFor: 'public api' stamp: 'avi 6/3/2005 15:40'!
clear
	self class: 'clear'.
	self with: [canvas space]! !

!WADivTag methodsFor: 'accessing' stamp: 'avi 6/3/2005 15:39'!
tag
	^ 'div'! !

WATagBrush subclass: #WAFieldSetTag
	instanceVariableNames: 'legend'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-HTML-Tags'!

!WAFieldSetTag methodsFor: 'private' stamp: 'mb 3/8/2006 18:03'!
before
	legend ifNotNil: [canvas legend: legend]
! !

!WAFieldSetTag methodsFor: 'accessing' stamp: 'mb 3/8/2006 17:47'!
legend: aString
	legend _ aString
	! !

!WAFieldSetTag methodsFor: 'accessing' stamp: 'mb 3/8/2006 17:44'!
tag
	^ 'fieldset'! !

WATagBrush subclass: #WAFormInputTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-HTML-Tags'!

WAFormInputTag subclass: #WAAbstractTextAreaTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-HTML-Tags'!

!WAAbstractTextAreaTag commentStamp: '<historical>' prior: 0!
An abstract class to describe the HTML elements that can have a text cursor.
The cursorPosition i-var holds the desired cursor position!

!WAAbstractTextAreaTag methodsFor: 'javascript' stamp: 'mb 3/23/2006 17:25'!
setCursorPosition: anInteger
	| aStream |
	"Insert the javascript for setting the cursor position"
	self ensureId.
	aStream _ (String new: 30) writeStream.
	#setCursor.
	aStream
		nextPutAll: 'setCursor(';
		nextPutAll: self id printString.
	anInteger isNumber ifTrue:
		[aStream nextPutAll: ',' , anInteger asString].
	"Cursor will go at end of field value, if position is not a number"
	aStream nextPut: $).
	self session addLoadScript: aStream contents
! !

WAAbstractTextAreaTag subclass: #WATextAreaTag
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-HTML-Tags'!

!WATextAreaTag methodsFor: 'converting' stamp: 'mb 1/31/2006 11:56'!
callback: aBlock
	| callback |
	callback _ self fromStringConverterBlockFor: self value callback: aBlock.
	self name: (canvas callbacks registerCallback: callback).
	self value: self value asSeasideString.
! !

!WATextAreaTag methodsFor: 'attributes' stamp: 'ac 3/22/2005 17:49'!
columns: anInteger
	self attributeAt: 'cols' put: anInteger.! !

!WATextAreaTag methodsFor: 'attributes' stamp: 'ac 3/22/2005 17:50'!
rows: anInteger
	self attributeAt: 'rows' put: anInteger.! !

!WATextAreaTag methodsFor: 'accessing' stamp: 'ac 4/13/2005 01:51'!
tag
	^ 'textarea'! !

!WATextAreaTag methodsFor: 'accessing' stamp: 'mb 1/31/2006 11:42'!
value
	^value! !

!WATextAreaTag methodsFor: 'accessing' stamp: 'ac 8/30/2005 16:26'!
value: aString
	value _ aString! !

!WATextAreaTag methodsFor: 'public api' stamp: 'ac 8/30/2005 16:29'!
with: aBlock
	^ value ifNotNil: [super with: value] ifNil: [super with: aBlock]! !

WAAbstractTextAreaTag subclass: #WATextInputTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-HTML-Tags'!

WATextInputTag subclass: #WAEmailInputTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-HTML-Tags'!

!WAEmailInputTag methodsFor: 'as yet unclassified' stamp: 'chc 4/15/2012 10:38'!
type
	^ 'email'! !

WATextInputTag subclass: #WAPasswordInputTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-HTML-Tags'!

!WAPasswordInputTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 17:33'!
type
	^ 'password'! !

!WATextInputTag methodsFor: 'attributes' stamp: 'lr 10/10/2005 20:04'!
beRangeInput
	self type: 'range'.! !

!WATextInputTag methodsFor: 'attributes' stamp: 'lr 10/10/2005 20:04'!
beSearchInput
	self type: 'search'.! !

!WATextInputTag methodsFor: 'converting' stamp: 'chc 9/17/2010 14:37'!
callback: aBlock
	| callback |
	callback _ self fromStringConverterBlockFor: self value callback: aBlock.
	self name: (canvas callbacks registerCallback: callback).
	self value: self value asSeasideString.! !

!WATextInputTag methodsFor: 'attributes' stamp: 'ac 11/2/2005 18:06'!
disableEnter
	self onEnter: ''.! !

!WATextInputTag methodsFor: 'attributes' stamp: 'avi 1/23/2006 01:14'!
exampleText: aString
	self attributes at: 'value' ifAbsent:
		[self attributes
			at: 'onfocus' put: 'if(value == ', aString printString, '){value=''''; style.color=''black''}';
			at: 'style' put: 'color: #aaa';
			at: 'value' put: aString]! !

!WATextInputTag methodsFor: 'attributes' stamp: 'ac 11/30/2005 12:22'!
onEnter: aString
	self onKeyPress: 'if((window.event ? window.event.keyCode : event.which) == 13){', aString displayString, '; return false}; return true'! !

!WATextInputTag methodsFor: 'attributes' stamp: 'avi 9/29/2005 00:09'!
onKeyPress: anObject
	self attributeAt: 'onkeypress' put: anObject! !

!WATextInputTag methodsFor: 'attributes' stamp: 'avi 11/7/2005 14:09'!
size: aNumber
	self attributeAt: 'size' put: aNumber! !

!WATextInputTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:50'!
type
	^ 'text'! !

!WATextInputTag methodsFor: 'accessing' stamp: 'mb 1/30/2006 18:30'!
value
	^self attributes at: 'value' ! !

WAFormInputTag subclass: #WACheckboxTag
	instanceVariableNames: 'value callback'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-HTML-Tags'!

!WACheckboxTag methodsFor: 'javascript' stamp: 'mb 3/8/2006 18:20'!
canHaveShortcut
	^true! !

!WACheckboxTag methodsFor: 'attributes' stamp: 'pmm 7/19/2006 19:29'!
submitFormNamed: formName
	self onClick: 'submitForm('
				, formName asString printString 
				, '); return false;'.! !

!WACheckboxTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:44'!
type
	^ 'checkbox'! !

!WACheckboxTag methodsFor: 'attributes' stamp: 'lr 9/23/2005 13:47'!
value: aBoolean
	self attributeAt: 'checked' put: aBoolean.! !

WAFormInputTag subclass: #WAFileUploadTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-HTML-Tags'!

!WAFileUploadTag methodsFor: 'callbacks' stamp: 'lr 9/23/2005 13:45'!
callback: aBlock
	aBlock fixTemps.
	super callback: [ :file | aBlock value: (file = '' ifFalse: [ file ]) ].! !

!WAFileUploadTag methodsFor: 'callbacks' stamp: 'lr 10/19/2005 00:13'!
on: selector of: anObject
	self callback: [ :value | anObject perform: selector asMutator with: value ].! !

!WAFileUploadTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:45'!
type
	^ 'file'! !

!WAFormInputTag methodsFor: 'callbacks' stamp: 'chc 9/7/2010 15:27'!
callback: aBlock
	self name: (canvas callbacks registerCallback: aBlock).! !

!WAFormInputTag methodsFor: 'converting' stamp: 'mb 3/23/2006 07:41'!
fromStringConverterBlockFor: anObject callback: aBlock
	^ [:v |
	aBlock value: 
		( [anObject convertSeasideString: v] on: Error do: [:e | v] )
	]
! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'lr 9/23/2005 13:41'!
name: aString
	self attributes at: 'name' put: aString.! !

!WAFormInputTag methodsFor: 'callbacks' stamp: 'mb 2/9/2006 14:51'!
on: selector of: anObject
	self ensureId: selector.
	self value: (anObject perform: selector).
	self callback: [ :value | anObject perform: selector asMutator with: value ].! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'lr 9/23/2005 17:43'!
readonly: aBoolean
	self attributes at: 'readonly' put: aBoolean.! !

!WAFormInputTag methodsFor: 'javascript' stamp: 'mb 3/23/2006 09:03'!
setFocus
	self ensureId.
	#setFocus.
	self session addLoadScript: 'setFocus(', self id printString, ')'! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'mb 3/9/2006 10:23'!
submitOnClick
	#submit.
	self onClick: 'submit()'.! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'lr 10/10/2005 19:49'!
tabindex: anInteger
	self attributes at: 'tabindex' put: anInteger.! !

!WAFormInputTag methodsFor: 'accessing' stamp: 'ac 3/16/2005 12:08'!
tag
	^ 'input'! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'lr 9/23/2005 13:42'!
text: aString
	self value: aString.! !

!WAFormInputTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:43'!
type
	^ nil! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'lr 10/10/2005 19:49'!
type: aString
	self attributes at: 'type' put: aString.! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'mb 1/30/2006 18:59'!
value
	^self attributes at: 'value' ! !

!WAFormInputTag methodsFor: 'attributes' stamp: 'lr 9/23/2005 13:42'!
value: anObject
	anObject ifNotNil: [ self attributes at: 'value' put: anObject ].! !

!WAFormInputTag methodsFor: 'public' stamp: 'lr 9/23/2005 14:10'!
with: aBlock
	self type isNil ifFalse: [
		self attributes at: 'type' ifAbsentPut: [ self type ].
		self class: self type ].
	super with: aBlock.! !

WAFormInputTag subclass: #WAHiddenInputTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-HTML-Tags'!

!WAHiddenInputTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 17:45'!
type
	^ 'hidden'! !

WAFormInputTag subclass: #WARadioButtonTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-HTML-Tags'!

!WARadioButtonTag methodsFor: 'attributes' stamp: 'ac 7/6/2005 10:39'!
beChecked
	self attributeAt: 'checked' put: true.! !

!WARadioButtonTag methodsFor: 'attributes' stamp: 'ac 7/6/2005 10:40'!
beUnchecked
	self attributeAt: 'checked' put: false.! !

!WARadioButtonTag methodsFor: 'callbacks' stamp: 'ac 7/6/2005 11:24'!
callback: aBlock
	self attributeAt: 'value' put: (canvas callbacks registerCallback: aBlock).! !

!WARadioButtonTag methodsFor: 'javascript' stamp: 'mb 3/8/2006 18:20'!
canHaveShortcut
	^true! !

!WARadioButtonTag methodsFor: 'attributes' stamp: 'ac 7/6/2005 11:32'!
group: aRadioGroup
	self name: aRadioGroup key.! !

!WARadioButtonTag methodsFor: 'attributes' stamp: 'ac 7/6/2005 11:01'!
selected: aBoolean
	self attributeAt: 'checked' put: aBoolean.! !

!WARadioButtonTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:46'!
type
	^ 'radio'! !

WAFormInputTag subclass: #WASubmitButtonTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-HTML-Tags'!

WASubmitButtonTag subclass: #WAButtonTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-HTML-Tags'!

!WAButtonTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 17:37'!
type
	^ 'button'! !

WASubmitButtonTag subclass: #WAImageButtonTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-HTML-Tags'!

!WAImageButtonTag methodsFor: 'attributes' stamp: 'mb 6/8/2006 16:08'!
callback: aBlock
	self attributes at: 'name' ifAbsentPut: [canvas callbacks registerImageCallback: aBlock].! !

!WAImageButtonTag methodsFor: 'attributes' stamp: 'lr 9/14/2005 22:02'!
extent: aPoint
	self width: aPoint x; height: aPoint y.! !

!WAImageButtonTag methodsFor: 'attributes' stamp: 'lr 9/14/2005 22:04'!
form: aForm
	self extent: aForm extent.
	self url: (canvas context urlForDocument: aForm).! !

!WAImageButtonTag methodsFor: 'attributes' stamp: 'lr 8/3/2006 08:43'!
height: aNumber
	self attributes at: 'height' put: aNumber! !

!WAImageButtonTag methodsFor: 'attributes' stamp: 'lr 9/14/2005 22:03'!
resourceUrl: aString
	self url: (canvas document root absoluteUrlForResource: aString).! !

!WAImageButtonTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:49'!
type
	^ 'image'! !

!WAImageButtonTag methodsFor: 'attributes' stamp: 'lr 9/14/2005 22:02'!
url: aString
	self attributes at: 'src' put: aString.! !

!WAImageButtonTag methodsFor: 'attributes' stamp: 'lr 8/3/2006 08:43'!
width: aNumber
	self attributes at: 'width' put: aNumber! !

!WASubmitButtonTag methodsFor: 'callbacks' stamp: 'mb 1/5/2006 14:08'!
callback: aBlock
	self attributes at: 'name' ifAbsentPut: [canvas callbacks registerActionCallback: aBlock].
	
! !

!WASubmitButtonTag methodsFor: 'javascript' stamp: 'mb 3/8/2006 18:19'!
canHaveShortcut
	^true! !

!WASubmitButtonTag methodsFor: 'callbacks' stamp: 'jlr 4/13/2006 13:26'!
on: aSymbol of: anObject
	self value: (self labelForSelector: aSymbol of: anObject).
	self callback: [anObject perform: aSymbol ].! !

!WASubmitButtonTag methodsFor: 'accessing' stamp: 'lr 9/23/2005 13:49'!
type
	^ 'submit'! !

WATagBrush subclass: #WAFormTag
	instanceVariableNames: 'defaultAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-HTML-Tags'!

!WAFormTag methodsFor: 'attributes' stamp: 'lr 7/9/2006 18:56'!
action: aString
	self attributeAt: 'action' put: aString! !

!WAFormTag methodsFor: 'private' stamp: 'avi 3/23/2006 23:07'!
before
	defaultAction ifNotNil: [
		canvas submitButton
			callback: defaultAction;
			value: 'Default';
			style: 'position: absolute; top: -100em';
			with: nil.
		canvas textInput
			callback: [:v];
			style: 'position: absolute; top: -100em'  ].! !

!WAFormTag methodsFor: 'callbacks' stamp: 'ac 4/13/2005 00:02'!
defaultAction: aBlock
	defaultAction _ aBlock.! !

!WAFormTag methodsFor: 'attributes' stamp: 'lr 7/9/2006 18:57'!
method: aString
	self attributeAt: 'method' put: aString! !

!WAFormTag methodsFor: 'attributes' stamp: 'avi 6/8/2005 21:46'!
multipart
	self attributeAt: 'enctype' put: 'multipart/form-data'! !

!WAFormTag methodsFor: 'attributes' stamp: 'lr 9/14/2005 21:37'!
multipart: aBoolean
	aBoolean ifTrue: [ self multipart ].! !

!WAFormTag methodsFor: 'attributes' stamp: 'avi 6/9/2005 16:02'!
name: aString
	self attributeAt: 'name' put: aString! !

!WAFormTag methodsFor: 'attributes' stamp: 'avi 3/21/2006 16:51'!
noAutocomplete
	self attributeAt: 'autocomplete' put: 'off'! !

!WAFormTag methodsFor: 'attributes' stamp: 'lr 7/9/2006 18:57'!
post
	self method: 'post'! !

!WAFormTag methodsFor: 'initialize-release' stamp: 'chc 2/22/2011 10:12'!
setParent: aBrush canvas: aCanvas
	super setParent: aBrush canvas: aCanvas.
	self post; action: canvas context request url
	! !

!WAFormTag methodsFor: 'private' stamp: 'avi 6/17/2004 11:29'!
tag
	^ 'form'! !

WATagBrush subclass: #WAGenericTag
	instanceVariableNames: 'tag token'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-HTML'!

!WAGenericTag commentStamp: 'chc 10/23/2011 12:19' prior: 0!
A generic tag is easy to produce for the canvas. A letter goes into the #tag instvar. Say p, b, or i. Then it is bracketed by angle brackets. Content is then added to the document. Then the same tag is added except with a forward slash. 

p
<p>
contented added to the document
</p>

These html tags are easy for the canvas to make. The more complicated ones get their own class in the HTML-Tags class category.

Because there are tag that are tied still closely to Seaside callbacks, you can run into errors (because I haven't created tests for the GreenNeon canvas). Go to the class for the tag, say WASelectTag, and delete its 
#with selector. That will lobotomize it quite nicely, and it will start to do what you want. !

!WAGenericTag class methodsFor: 'as yet unclassified' stamp: 'avi 6/13/2004 00:53'!
tag: aString
	^ self basicNew initializeWithTag: aString! !

!WAGenericTag methodsFor: 'initialize-release' stamp: 'avi 6/13/2004 00:40'!
initializeWithTag: aString
	tag _ aString! !

!WAGenericTag methodsFor: 'accessing' stamp: 'avi 6/13/2004 00:40'!
tag
	^ tag! !

!WAGenericTag methodsFor: 'accessing' stamp: 'chc 2/11/2011 23:30'!
tag: aTag
	
	tag := aTag! !

!WAGenericTag methodsFor: 'accessing' stamp: 'chc 2/11/2011 23:38'!
token
	"Answer the value of token"

	^ token! !

!WAGenericTag methodsFor: 'accessing' stamp: 'chc 2/11/2011 23:38'!
token: anObject
	"Set the value of token"

	token := anObject! !

!WAGenericTag methodsFor: 'accessing' stamp: 'chc 10/23/2011 11:50'!
write

	"pay no attention to this. some test I did"

	^ self chico , ' ' , token asString , '.'! !

!WAGenericTag methodsFor: 'accessing' stamp: 'chc 10/23/2011 11:51'!
write: aString

	"pay no attention to this. some test I did"

	^'c paragraph: ' ,  aString  , '.'! !

WATagBrush subclass: #WAHeadingTag
	instanceVariableNames: 'level'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-HTML-Tags'!

!WAHeadingTag methodsFor: 'accessing' stamp: 'ac 3/16/2005 14:12'!
level
	^ level ifNil: [1]! !

!WAHeadingTag methodsFor: 'attributes' stamp: 'ac 3/16/2005 14:12'!
level1
	level _ 1.! !

!WAHeadingTag methodsFor: 'attributes' stamp: 'ac 3/16/2005 14:12'!
level2
	level _ 2.! !

!WAHeadingTag methodsFor: 'attributes' stamp: 'ac 3/16/2005 14:12'!
level3
	level _ 3.! !

!WAHeadingTag methodsFor: 'attributes' stamp: 'ac 3/16/2005 14:12'!
level4
	level _ 4.! !

!WAHeadingTag methodsFor: 'attributes' stamp: 'dc 8/16/2006 07:43'!
level5
	level _ 5.! !

!WAHeadingTag methodsFor: 'attributes' stamp: 'dc 8/16/2006 07:43'!
level6
	level _ 6.! !

!WAHeadingTag methodsFor: 'attributes' stamp: 'lr 9/14/2005 21:33'!
level: anInteger
	level := anInteger! !

!WAHeadingTag methodsFor: 'accessing' stamp: 'avi 5/10/2005 14:33'!
tag
	^ 'h', self level displayString ! !

WATagBrush subclass: #WAIframeTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-HTML-Tags'!

!WAIframeTag methodsFor: 'conveniance' stamp: 'lr 3/10/2006 12:36'!
contents: anObject
	| key |
	key := canvas callbacks registerActionCallback: [ self performRendering: anObject ].
	self src: (canvas context actionUrl withParameter: key)! !

!WAIframeTag methodsFor: 'conveniance' stamp: 'lr 8/9/2006 08:34'!
document: anObject
	self document: anObject mimeType: nil! !

!WAIframeTag methodsFor: 'conveniance' stamp: 'lr 8/9/2006 08:31'!
document: anObject mimeType: aMimeString
	self document: anObject mimeType: aMimeString fileName: nil! !

!WAIframeTag methodsFor: 'conveniance' stamp: 'lr 8/9/2006 08:31'!
document: anObject mimeType: aMimeString fileName: aFileNameString
	self src: (canvas context
		urlForDocument: anObject 
		mimeType: aMimeString 
		fileName: aFileNameString)! !

!WAIframeTag methodsFor: 'attributes' stamp: 'lr 8/3/2006 08:42'!
height: anInteger
	self attributes at: 'height' put: anInteger! !

!WAIframeTag methodsFor: 'attributes' stamp: 'lr 3/10/2006 12:18'!
name: aString
	self attributes at: 'name' put: aString! !

!WAIframeTag methodsFor: 'private' stamp: 'mb 8/18/2006 10:26'!
performRendering: anObject
	| innerContext docRoot session document response renderer  |
	innerContext := canvas context copy.
	docRoot := WARenderedHtmlRoot context: innerContext.
	docRoot 
		resourceBaseUrl: innerContext document root resourceBaseUrl;
		addHeadElement: ((WAHtmlElement named: 'base')
			attributeAt: 'target' put: '_top';
			yourself).
	session := WACurrentSession value.
	document := session outputDocumentClass root: docRoot.
	response := WAResponse new.
	response headerAt: 'Cache-Control' put: 'No-cache'.
	document stream: response stream.
	canvas context document: document.
	renderer := canvas species context: canvas context callbacks: canvas callbacks.
	renderer render: anObject; flush. 
	document close.
	session returnResponse: response! !

!WAIframeTag methodsFor: 'attributes' stamp: 'pmm 8/26/2006 00:07'!
src: anUrl
	"should be deprecated"
	self url: anUrl! !

!WAIframeTag methodsFor: 'accessing' stamp: 'lr 3/8/2006 23:25'!
tag
	^ 'iframe'! !

!WAIframeTag methodsFor: 'attributes' stamp: 'pmm 8/26/2006 00:06'!
url: aString
	self attributeAt: 'src' put: aString! !

!WAIframeTag methodsFor: 'attributes' stamp: 'lr 8/3/2006 08:43'!
width: anInteger
	self attributes at: 'width' put: anInteger! !

WATagBrush subclass: #WALabelTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-HTML-Tags'!

!WALabelTag methodsFor: 'attributes' stamp: 'ac 7/9/2005 04:36'!
for: aString
	self attributeAt: 'for' put: aString.! !

!WALabelTag methodsFor: 'accessing' stamp: 'ac 7/9/2005 04:36'!
tag
	^ 'label'! !

WATagBrush subclass: #WAOptionTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-HTML-Tags'!

!WAOptionTag methodsFor: 'attributes' stamp: 'ac 3/17/2005 17:53'!
callback: aBlock
	self attributeAt: 'value' put: (canvas callbacks registerCallback: aBlock).! !

!WAOptionTag methodsFor: 'attributes' stamp: 'pmm 7/19/2006 20:06'!
on: selector of: anObject
	"copy pasted from WASelectTag, we need a traitified version of seaside"
	self selected: (anObject perform: selector).
	self callback: [ :value | anObject perform: selector asMutator with: value ].! !

!WAOptionTag methodsFor: 'attributes' stamp: 'ac 3/17/2005 17:13'!
selected: aBoolean
	self attributeAt: 'selected' put: aBoolean.! !

!WAOptionTag methodsFor: 'accessing' stamp: 'ac 3/17/2005 17:13'!
tag
	^ 'option'! !

WATagBrush subclass: #WAScriptTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-HTML-Tags'!

!WAScriptTag methodsFor: 'accessing' stamp: 'dwj 6/10/2005 13:10'!
tag
	^ 'script'! !

!WAScriptTag methodsFor: 'attributes' stamp: 'pmm 8/26/2006 00:05'!
url: aString
	self attributes at: 'src' put: aString! !

!WAScriptTag methodsFor: 'public api' stamp: 'mb 3/16/2006 23:51'!
with: aBlock
	isClosed := true.
	self attributes at: 'type' ifAbsentPut: ['text/javascript'].
	self openTag.
	canvas html: aBlock.
	self closeTag.
! !

WATagBrush subclass: #WATableCellTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-HTML-Tags'!

!WATableCellTag methodsFor: 'attributes' stamp: 'lr 9/26/2005 12:08'!
align: aString
	self attributes at: 'align' put: aString.! !

!WATableCellTag methodsFor: 'attributes' stamp: 'lr 9/26/2005 12:08'!
colSpan: anInteger
	self attributes at: 'colspan' put: anInteger.! !

!WATableCellTag methodsFor: 'attributes' stamp: 'lr 9/26/2005 12:08'!
rowSpan: anInteger
	self attributes at: 'rowspan' put: anInteger.! !

!WATableCellTag methodsFor: 'attributes' stamp: 'lr 9/26/2005 12:09'!
verticalAlign: aString
	self attributes at: 'valign' put: aString.! !

WATableCellTag subclass: #WATableDataTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-HTML-Tags'!

!WATableDataTag methodsFor: 'accessing' stamp: 'ac 3/17/2005 22:09'!
tag
	^ 'td'! !

WATableCellTag subclass: #WATableHeadingTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-HTML-Tags'!

!WATableHeadingTag methodsFor: 'accessing' stamp: 'ac 3/17/2005 22:10'!
tag
	^ 'th'! !

WATagBrush subclass: #WATableTag
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-HTML-Tags'!

!WATableTag methodsFor: 'attributes' stamp: 'lr 8/3/2006 08:44'!
cellpadding: anInteger
	self attributes at: 'cellpadding' put: anInteger! !

!WATableTag methodsFor: 'attributes' stamp: 'lr 8/3/2006 08:44'!
cellspacing: anInteger
	self attributes at: 'cellspacing' put: anInteger! !

!WATableTag methodsFor: 'attributes' stamp: 'lr 8/3/2006 08:45'!
layout
	self attributes
		at: 'border' put: 0;
		at: 'cellspacing' put: 0;
		at: 'cellpadding' put: 0! !

!WATableTag methodsFor: 'accessing' stamp: 'ac 3/16/2005 15:22'!
tag
	^ 'table'! !

!WATagBrush class methodsFor: 'code generation' stamp: 'mb 3/16/2006 16:01'!
tag
	"((( WASelectTag tag )))"
	"((( WAGenericTag tag )))"
	^(self selectors includes: #tag) ifTrue: [self new tag] ifFalse: [nil].! !

!WATagBrush methodsFor: 'attributes' stamp: 'ac 3/16/2006 10:57'!
accessKey: aString
	self attributeAt: 'accesskey' put: aString! !

!WATagBrush methodsFor: 'javascript' stamp: 'mb 3/23/2006 08:55'!
addShortcut: aString
	| aStream |
	self canHaveShortcut ifFalse:
		[self error: 'May not assign shortcut on items that are not clickable'].
	aString notNil ifTrue:
		[aStream _ (String new: 30) writeStream.
		self ensureId.
		#addShortcut.
		aStream
			nextPutAll: 'addShortcut(';
			nextPutAll: aString printString;
			nextPut: $,;
			nextPutAll: self id printString;
			nextPut: $).
		self session addLoadScript: aStream contents].
		! !

!WATagBrush methodsFor: 'attributes' stamp: 'mb 3/8/2006 17:51'!
addStyle: aString
	self attributes addStyle: aString.! !

!WATagBrush methodsFor: 'private' stamp: 'ac 3/17/2005 18:18'!
after! !

!WATagBrush methodsFor: 'attributes' stamp: 'mb 3/23/2006 17:08'!
attributeAt: key
	^(self attributes at: key ifAbsent: [key -> nil]) value.! !

!WATagBrush methodsFor: 'attributes' stamp: 'avi 6/17/2004 12:40'!
attributeAt: key put: value
	self attributes at: key put: value! !

!WATagBrush methodsFor: 'attributes' stamp: 'avi 6/13/2004 01:03'!
attributes
	^ attributes ifNil: [attributes _ WAHtmlAttributes new]! !

!WATagBrush methodsFor: 'attributes' stamp: 'avi 6/17/2004 14:15'!
attributes: anHtmlAttributes
	attributes _ anHtmlAttributes
! !

!WATagBrush methodsFor: 'private' stamp: 'ac 3/17/2005 18:18'!
before! !

!WATagBrush methodsFor: 'javascript' stamp: 'mb 3/8/2006 18:18'!
canHaveShortcut
	^false! !

!WATagBrush methodsFor: 'attributes' stamp: 'avi 6/22/2005 01:49'!
class: aString
	self attributes addClass: aString! !

!WATagBrush methodsFor: 'private' stamp: 'mb 3/16/2006 23:19'!
closeTag
	self document closeTag: self tag.
! !

!WATagBrush methodsFor: 'javascript' stamp: 'avi 3/9/2006 17:41'!
confirm: aString
	self onClick: 'return confirm("', aString, '")'! !

!WATagBrush methodsFor: 'attributes' stamp: 'ac 10/16/2005 19:55'!
disabled
	self disabled: true.! !

!WATagBrush methodsFor: 'attributes' stamp: 'ac 10/16/2005 19:55'!
disabled: aBoolean
	self attributes at: 'disabled' put: aBoolean.! !

!WATagBrush methodsFor: 'accessing' stamp: 'avi 6/13/2004 00:39'!
document
	^ canvas document! !

!WATagBrush methodsFor: 'public' stamp: 'mb 3/31/2006 11:36'!
ensureId

	"This verifies whether a value has been previously supplied
	for the id= attribute, and, if not, 
	a non-nil default value is automatically supplied

	Answers the value of the id= attribute"

	^self ensureIdUsing: [canvas nextId].
! !

!WATagBrush methodsFor: 'public' stamp: 'mb 3/23/2006 16:59'!
ensureId: aString

	"This verifies whether a value has been previously supplied
	for the id= attribute, and, if not, 
	the argument value is used for the id= attribute

	The argument is expected to be non nil

	Answers the value of the id= attribute"

	^self ensureIdUsing: [aString]! !

!WATagBrush methodsFor: 'private' stamp: 'mb 3/27/2006 23:37'!
ensureIdUsing: aBlock

	"This verifies whether a value has been previously supplied
	for the id= attribute, and, if not, 
	the non-nil argument value is remembered

	Answers the value of the id= attribute"

	^self id ifNil: 
		[ | idValue |
		idValue _ aBlock value.
		idValue isNil ifTrue: [self error: 'Ensuring a nil value : does this make sense ?'].
		idValue ifNil: [self ensureId] ifNotNil: [self id: idValue. idValue]]! !

!WATagBrush methodsFor: 'private' stamp: 'mb 3/31/2006 11:42'!
getId
	"Compatibility"
	^ canvas nextId.! !

!WATagBrush methodsFor: 'accessing' stamp: 'mb 3/23/2006 17:09'!
id

	"Convert to a String in case it was supplied as a Symbol"

	| idValue |
	idValue _ self attributeAt: 'id'.
	^idValue ifNotNil: [idValue asString]
! !

!WATagBrush methodsFor: 'attributes' stamp: 'mb 3/23/2006 17:00'!
id: aString
	self attributeAt: 'id' put: aString.
! !

!WATagBrush methodsFor: 'javascript' stamp: 'ac 10/5/2005 00:16'!
ignoreURL
	^ self onClick: 'return false'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:48'!
onBlur: aString
	"The onblur event occurs when an element loses focus either by the pointing device or by tabbing navigation."

	self attributes at: 'onblur' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:48'!
onChange: aString
	"The onchange event occurs when a control loses the input focus and its value has been modified since gaining focus."

	self attributes at: 'onchange' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:48'!
onClick: aString
	"The onclick event occurs when the pointing device button is clicked over an element."

	self attributes at: 'onclick' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:48'!
onDoubleClick: aString
	"The ondblclick event occurs when the pointing device button is double clicked over an element."

	self attributes at: 'ondblclick' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:48'!
onError: aString
	self attributes at: 'onerror' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:48'!
onFocus: aString
	"The onfocus event occurs when an element receives focus either by the pointing device or by tabbing navigation."

	self attributes at: 'onfocus' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:48'!
onKeyDown: aString
	"The onkeydown event occurs when a key is pressed down over an element."

	self attributes at: 'onkeydown' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:48'!
onKeyPress: aString
	"The onkeypress event occurs when a key is pressed and released over an element."

	self attributes at: 'onkeypress' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:48'!
onKeyUp: aString
	"The onkeyup event occurs when a key is released over an element."

	self attributes at: 'onkeyup' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'mb 6/21/2006 18:28'!
onLoad: aString
	"The onload event occurs when the user agent finishes loading a window."

	self attributes at: 'onload' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:48'!
onMouseDown: aString
	"The onmousedown event occurs when the pointing device button is pressed over an element."

	self attributes at: 'onmousedown' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:48'!
onMouseMove: aString
	"The onmousemove event occurs when the pointing device is moved while it is over an element."

	self attributes at: 'onmousemove' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:48'!
onMouseOut: aString
	"The onmouseout event occurs when the pointing device is moved away from an element."

	self attributes at: 'onmouseout' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:48'!
onMouseOver: aString
	"The onmouseover event occurs when the pointing device is moved onto an element."

	self attributes at: 'onmouseover' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:48'!
onMouseUp: aString
	"The onmouseup event occurs when the pointing device button is released over an element."

	self attributes at: 'onmouseup' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:49'!
onReset: aString
	"The onreset event occurs when a form is reset."

	self attributes at: 'onreset' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:49'!
onResize: aString
	self attributes at: 'onresize' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:49'!
onScroll: aString
	self attributes at: 'onscroll' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:49'!
onSelect: aString
	"The onselect event occurs when a user selects some text in a text field."

	self attributes at: 'onselect' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:49'!
onSubmit: aString
	"The onsubmit event occurs when a form is submitted."

	self attributes at: 'onsubmit' append: aString separator: ';'! !

!WATagBrush methodsFor: 'events' stamp: 'lr 6/7/2006 13:49'!
onUnload: aString
	"The onunload event occurs when the user agent removes a document from a window."

	self attributes at: 'onunload' append: aString separator: ';'! !

!WATagBrush methodsFor: 'private' stamp: 'CC 8/4/2010 15:32'!
openTag

	self document openTag: self tag attributes: attributes.! !

!WATagBrush methodsFor: 'public' stamp: 'avi 3/18/2005 22:10'!
section: aSymbol
	self class: (canvas painter classForSection: aSymbol).
	self with: [canvas painter perform: aSymbol with: canvas]! !

!WATagBrush methodsFor: 'attributes' stamp: 'mb 2/19/2006 16:26'!
style: aString
	self attributes addStyle: aString! !

!WATagBrush methodsFor: 'accessing' stamp: 'avi 6/13/2004 00:30'!
tag
	self subclassResponsibility! !

!WATagBrush methodsFor: 'attributes' stamp: 'lr 9/23/2005 13:51'!
tooltip: aString
	aString ifNotNil: [ self attributeAt: 'title' put: aString ].! !

!WATagBrush methodsFor: 'public' stamp: 'CC 8/4/2010 15:41'!
with: aBlock
	self openTag.
	super with: [self within: aBlock].
	self closeTag.

	"canvas nest: [self within: aBlock]"
! !

!WATagBrush methodsFor: 'convenience' stamp: 'avi 3/16/2006 12:20'!
withLineBreaks: aString
	self with: [canvas withLineBreaks: aString]! !

!WATagBrush methodsFor: 'private' stamp: 'chc 9/9/2010 15:28'!
within: aBlock
	self before.
	aBlock renderOn: canvas.
	self after.! !

Object subclass: #WACanvas
	instanceVariableNames: 'currentBrush parentBrush painter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-HTML'!

!WACanvas methodsFor: 'public api' stamp: 'avi 6/17/2004 12:36'!
brush: aBrush
	self flush.
	currentBrush _ aBrush.
	aBrush setParent: parentBrush canvas: self.
	^ aBrush! !

!WACanvas methodsFor: 'private' stamp: 'avi 6/17/2004 12:12'!
flush
	currentBrush ifNotNil:
		[currentBrush close.
		currentBrush _ nil]! !

!WACanvas methodsFor: 'private' stamp: 'mb 1/30/2006 18:12'!
forgetCurrentBrush
	currentBrush _ nil.! !

!WACanvas methodsFor: 'private' stamp: 'avi 9/21/2005 23:19'!
insert: aBlock
	| oldBrush |
	oldBrush _ currentBrush.
	currentBrush _ nil.
	aBlock value.
	currentBrush _ oldBrush! !

!WACanvas methodsFor: 'private' stamp: 'avi 6/17/2004 12:37'!
nest: aBlock
	parentBrush _ currentBrush.
	currentBrush _ nil.
	aBlock renderOn: self.
	self flush.
	parentBrush _ parentBrush parent.
! !

!WACanvas methodsFor: 'accessing' stamp: 'avi 3/18/2005 21:56'!
painter
	^ painter! !

!WACanvas methodsFor: 'accessing' stamp: 'avi 3/18/2005 21:56'!
painter: anObject
	painter _ anObject! !

WACanvas subclass: #WAHtmlCanvas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-HTML'!

!WAHtmlCanvas class methodsFor: 'as yet unclassified' stamp: 'ac 7/9/2005 04:31'!
generateBinaryFor: aCollection
	(aCollection size = 3 and: [(self includesSelector: aCollection third) not]) ifTrue:
		[self 
			compile: aCollection third, ' aBlock
	self ', aCollection second, ' with: aBlock'
			classified: self generatedCategory].
! !

!WAHtmlCanvas class methodsFor: 'as yet unclassified' stamp: 'mb 3/16/2006 16:04'!
generateTags
	"((( WAHtmlCanvas generateTags )))"
	self tags do:
		[:spec |
		self generateUnaryFor: spec.
		self generateBinaryFor: spec].! !

!WAHtmlCanvas class methodsFor: 'as yet unclassified' stamp: 'ac 7/9/2005 04:29'!
generateUnaryFor: aCollection
	(self includesSelector: aCollection second) ifFalse:
		[self 
			compile: aCollection second, '
	^ self ', (self patternFor: aCollection first)
			classified: self generatedCategory]! !

!WAHtmlCanvas class methodsFor: 'as yet unclassified' stamp: 'ac 7/9/2005 04:30'!
generatedCategory
	^ 'html-generated'! !

!WAHtmlCanvas class methodsFor: 'as yet unclassified' stamp: 'mb 3/16/2006 16:04'!
patternFor: aString
	WATagBrush allSubclassesDo:
		[:each | each tag = aString
			ifTrue: [^ 'brush: ', each name, ' new']].
	^ 'tag: ', aString printString! !

!WAHtmlCanvas class methodsFor: 'as yet unclassified' stamp: 'mb 6/9/2006 18:56'!
tags
	"
	self generateTags
	"

	^ #(
		('a' anchor)
		('iframe' iframe)

		
		('p' paragraph paragraph:)
		('div' div div:)
		('span' span span:)

		('blockquote' blockquote blockquote:)
		('address' address address:)
		('dd' definitionData definitionData:)
		('dl' definitionList definitionList:)
		('dt' definitionTerm definitionTerm:)

		('code' code code:)
		('pre' preformatted preformatted:)
		('em' emphasis emphasis:)
		('b' bold bold:)
		('i' italic italic:)
		('u' underline underline:)
		('small' small small:)
		('big' big big:)
		('strong' strong strong:)
		('label' label label:)
		('legend' legend legend:)
		('acronym' acronym acronym:)
		('fieldset' fieldSet fieldSet:)

						
		('ul' unorderedList unorderedList:)
		('ol' orderedList orderedList:)
		('li' listItem listItem:)
		
		('br' break)
		('hr' horizontalRule)
		
		('form' form form:)
		('img' image image:)
		
		('table' table table:)
		('th' tableHeading tableHeading:)
		('tr' tableRow tableRow:)
		('td' tableData tableData:)
		('tbody' tableBody tableBody:)
		('thead' tableHead tableHead:)
		('tfoot' tableFoot tableFoot:)
		
		('script' script script:)
		)! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'chc 2/14/2011 12:07'!
a
	^ self brush: WAAnchorTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 3/8/2006 17:41'!
acronym
	^ self brush: WAAcronymTag new
! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 3/24/2006 13:42'!
acronym: aBlock
	self acronym with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 12/24/2005 17:43'!
address
	^ self tag: 'address'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 12/24/2005 17:44'!
address: aBlock
	self address with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'dwj 6/11/2005 06:04'!
anchor
	^ self brush: WAAnchorTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'ac 2/21/2006 14:36'!
big
	^ self tag: 'big'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'ac 2/21/2006 14:36'!
big: aBlock
	self big with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
blockquote
	^ self tag: 'blockquote'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
blockquote: aBlock
	self blockquote with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
bold
	^ self tag: 'b'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
bold: aBlock
	self bold with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'chc 2/14/2011 12:20'!
br
	^ self tag: 'br'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
break
	^ self tag: 'br'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'lr 5/18/2006 08:55'!
canvas
	^ self brush: WACanvasTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'lr 5/18/2006 08:55'!
canvas: aBlock
	^ self canvas with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
code
	^ self tag: 'code'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
code: aBlock
	self code with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 5/31/2006 20:26'!
definitionData
	^ self tag: 'dd'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 5/31/2006 20:26'!
definitionData: aBlock
	self definitionData with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 12/24/2005 17:39'!
definitionList
	^ self tag: 'dl'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 12/24/2005 17:42'!
definitionList: aBlock
	self definitionList with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 12/24/2005 17:42'!
definitionTerm
	^ self tag: 'dt'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'pmm 12/24/2005 17:42'!
definitionTerm: aBlock
	self definitionTerm with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
div
	^ self brush: WADivTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
div: aBlock
	self div with: aBlock! !

!WAHtmlCanvas methodsFor: 'accessing' stamp: 'avi 6/13/2004 00:57'!
document
	self subclassResponsibility! !

!WAHtmlCanvas methodsFor: '*greenneon-html5' stamp: 'chc 4/15/2012 10:37'!
emailInput
	^ self brush: WAEmailInputTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 3/8/2006 17:14'!
emphasis
	^ self tag: 'em'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 3/8/2006 17:14'!
emphasis: aBlock
	self emphasis with: aBlock! !

!WAHtmlCanvas methodsFor: 'encoding' stamp: 'chc 10/11/2011 10:11'!
encode: anObject

	^GNHtmlEncoder encode: anObject! !

!WAHtmlCanvas methodsFor: 'encoding' stamp: 'mbany 4/14/2005 12:26'!
encodeCharacter: aCharacter
	self html: ('&#', aCharacter asInteger displayString, ';').  ! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'ac 2/21/2006 17:15'!
fieldSet
	^ self brush: WAFieldSetTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 3/24/2006 13:45'!
fieldSet: aBlock
	self fieldSet with: aBlock! !

!WAHtmlCanvas methodsFor: '*greenneon-html5' stamp: 'chc 4/15/2012 10:17'!
fieldset
	^ self brush: WAFieldSetTag new! !

!WAHtmlCanvas methodsFor: '*greenneon-html5' stamp: 'chc 4/15/2012 10:19'!
fieldset: aBlock
	self fieldset with: aBlock! !

!WAHtmlCanvas methodsFor: 'html' stamp: 'avi 1/9/2006 21:56'!
form
	^ self tag: 'form'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
form: aBlock
	self form with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'ac 3/16/2005 14:14'!
heading
	^ self brush: WAHeadingTag new! !

!WAHtmlCanvas methodsFor: 'html' stamp: 'ac 3/16/2005 14:14'!
heading: aBlock
	self heading with: aBlock! !

!WAHtmlCanvas methodsFor: 'html' stamp: 'pmm 12/24/2005 17:38'!
heading: aBlock level: aNumber
	self heading
		level: aNumber;
		with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
horizontalRule
	^ self tag: 'hr'! !

!WAHtmlCanvas methodsFor: 'encoding' stamp: 'mbany 4/14/2005 12:26'!
html: aString
	self flush.
	self document text: aString displayString
! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 4/8/2006 10:56'!
iframe
	^ self brush: WAIframeTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'ac 3/16/2005 12:01'!
image
	^ self brush: WAImageTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 3/24/2006 13:51'!
image: aBlock
	self image with: aBlock! !

!WAHtmlCanvas methodsFor: 'html' stamp: 'lr 9/14/2005 22:22'!
imageForm: aForm
	self image form: aForm.! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'chc 2/14/2011 12:11'!
img
	^ self brush: WAImageTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
italic
	^ self tag: 'i'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
italic: aBlock
	self italic with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'ac 7/9/2005 04:37'!
label
	^ self brush: WALabelTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
label: aBlock
	self label with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 3/8/2006 17:59'!
legend
	^ self tag: 'legend'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 3/8/2006 18:00'!
legend: aBlock
	self legend with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'chc 2/16/2011 08:10'!
li: aBlock
	self listItem with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
listItem
	^ self tag: 'li'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
listItem: aBlock
	self listItem with: aBlock! !

!WAHtmlCanvas methodsFor: 'tagLoops' stamp: 'chc 2/16/2011 11:23'!
olArray: anArray
	
	
	 anArray do: [: ea | self orderedList with: [ self li: ea ]]! !

!WAHtmlCanvas methodsFor: 'html' stamp: 'lr 9/25/2005 11:52'!
orderedList
	^ self brush: WAListTag new beOrdered.! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'lr 9/25/2005 11:52'!
orderedList: aBlock
	self orderedList with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'chc 2/14/2011 12:05'!
p: aBlock
	self paragraph with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
paragraph
	^ self tag: 'p'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
paragraph: aBlock
	self paragraph with: aBlock! !

!WAHtmlCanvas methodsFor: 'html' stamp: 'ac 7/3/2005 15:46'!
popupAnchor
	^ self brush: WAPopupAnchorTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
preformatted
	^ self tag: 'pre'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
preformatted: aBlock
	self preformatted with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 3/24/2006 13:53'!
script
	^ self brush: WAScriptTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
script: aBlock
	self script with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
small
	^ self tag: 'small'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
small: aBlock
	self small with: aBlock! !

!WAHtmlCanvas methodsFor: 'html' stamp: 'avi 6/17/2004 15:07'!
space
	self html: '&nbsp;'! !

!WAHtmlCanvas methodsFor: 'html' stamp: 'mb 2/6/2006 10:48'!
space: n
	n timesRepeat: [self space].
! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
span
	^ self tag: 'span'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
span: aBlock
	self span with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'ac 3/20/2005 01:24'!
strong
	^ self tag: 'strong'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'ac 3/20/2005 01:24'!
strong: aBlock
	self strong with: aBlock! !

!WAHtmlCanvas methodsFor: 'html' stamp: 'avi 1/9/2006 22:05'!
submitButton
	^ self brush: WASubmitButtonTag new.! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
table
	^ self brush: WATableTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
table: aBlock
	self table with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
tableBody
	^ self tag: 'tbody'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
tableBody: aBlock
	self tableBody with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
tableData
	^ self brush: WATableDataTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
tableData: aBlock
	self tableData with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
tableFoot
	^ self tag: 'tfoot'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
tableFoot: aBlock
	self tableFoot with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
tableHead
	^ self tag: 'thead'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
tableHead: aBlock
	self tableHead with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'ac 3/17/2005 22:10'!
tableHeading
	^ self brush: WATableHeadingTag new! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'ac 3/16/2005 16:15'!
tableHeading: aBlock
	self tableHeading with: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
tableRow
	^ self tag: 'tr'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
tableRow: aBlock
	self tableRow with: aBlock! !

!WAHtmlCanvas methodsFor: 'public api' stamp: 'avi 6/17/2004 12:19'!
tag: aString
	^ self brush: (WAGenericTag tag: aString)! !

!WAHtmlCanvas methodsFor: 'encoding' stamp: 'lr 6/14/2006 08:05'!
text: anObject
	self html: (self encode: anObject)! !

!WAHtmlCanvas methodsFor: 'html' stamp: 'avi 1/9/2006 22:07'!
textInput
	^ self brush: WATextInputTag new! !

!WAHtmlCanvas methodsFor: 'tagLoops' stamp: 'chc 3/5/2011 13:34'!
tr: aRow do: aBlock! !

!WAHtmlCanvas methodsFor: 'tagLoops' stamp: 'chc 3/5/2011 13:34'!
ul: anItem do: aBlock! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 3/8/2006 17:31'!
underline
	^ self tag: 'u'! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'mb 3/8/2006 17:32'!
underline: aBlock
	self underline with: aBlock! !

!WAHtmlCanvas methodsFor: 'html' stamp: 'lr 9/25/2005 11:51'!
unorderedList
	^ self brush: WAListTag new beUnordered.! !

!WAHtmlCanvas methodsFor: 'html-generated' stamp: 'avi 6/3/2005 15:40'!
unorderedList: aBlock
	self unorderedList with: aBlock! !

!WAHtmlCanvas methodsFor: 'encoding' stamp: 'avi 2/17/2006 20:36'!
withLineBreaks: aString
	| stream |
	stream _ aString readStream.
	[stream atEnd] whileFalse:
		[self text: stream nextLine.
		stream atEnd ifFalse: [self break]]! !

WAHtmlCanvas subclass: #WARenderCanvas
	instanceVariableNames: 'context callbacks view'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-HTML'!

!WARenderCanvas commentStamp: 'chc 10/23/2011 12:16' prior: 0!
WARenderCanvas and WAHtmlCanvas contain all the selectors for tags used in creating a webpage. 

c paragraph: 'This is some text'.

The #paragraph: selector will be found in one of these two classes. Almost all the possible tags in Html are represented here. Each selector creates a class that creates a tag. Those classes are in the HTML-Tags class category.

The context instvar contains an instance of WARenderingContext. The callbacks instvar is a holdover from Seaside and is still there for when callbacks get added to GreenNeon. The view is page we're making and is a subclass of HVTransientView. 

Usually you remember the name of a tag, but if you forget, then you come here to remember. Oh yea, unordered list takes a #unorderedList selector after the #c. When you forget the attributes of a tag, then you go to the class that creates it in HTML-Tags and look at the selectors there. The #image tag can add the #url: selector and you can see it listed in WAImageTag. 

There are two kinds of tags/classes in the canvas -- generic and custom. 

!

!WARenderCanvas class methodsFor: 'as yet unclassified' stamp: 'avi 6/13/2004 00:59'!
context: aRenderingContext callbacks: aCallbackStore
	^ self basicNew initializeWithContext: aRenderingContext callbacks: aCallbackStore! !

!WARenderCanvas methodsFor: 'form-buttons' stamp: 'chc 10/7/2011 10:03'!
asWebCookieResponseTo: aRequest account: anAccount

	| server id | 

	context document close.
	
	"aRequest send200Response: context document stream contents contentType: 'text/html'."
	
	server :=  WebServer default.
	server sessionAt: (id := anAccount id hex) put: anAccount.
	aRequest send200Response: context document stream contents contentType: 'text/html' do: 
	[:resp| resp setCookie: 'session' value: id path: '/'].


	"Time totalSeconds"
	
	
	
	! !

!WARenderCanvas methodsFor: 'form-buttons' stamp: 'chc 10/12/2011 10:52'!
asWebResponseTo: aRequest


	context document close.
	
	aRequest send200Response: context document stream contents contentType: 'text/html; charset=ISO-8859-1'
	
	
	
	
	! !

!WARenderCanvas methodsFor: 'accessing' stamp: 'chc 10/13/2011 11:09'!
buildHead

	"context document root linkToStyle: 'http://smalltalktelevision.com/resources/start.css'."
	
	(view respondsTo: #title) ifTrue: [ context document root title: view title. ].
	(view respondsTo: #style) ifTrue: [ context document root addStyle: view style].
	(view respondsTo: #script) ifTrue: [ context document root addScript: view script].
	
	((context request isPostRequest) and: [view respondsTo: #processForm]) ifTrue: [ 
		"put something here to put the values from the request into the instvars"
		view processForm ].
	! !

!WARenderCanvas methodsFor: 'form-buttons' stamp: 'lr 9/23/2005 18:07'!
button
	^ self brush: WAButtonTag new.! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'avi 4/28/2005 14:01'!
checkbox
	^ self brush: WACheckboxTag new	! !

!WARenderCanvas methodsFor: 'private' stamp: 'avi 7/5/2004 11:56'!
close
	self flush.! !

!WARenderCanvas methodsFor: 'accessing' stamp: 'avi 6/13/2004 01:01'!
context
	^ context! !

!WARenderCanvas methodsFor: 'accessing' stamp: 'chc 9/4/2010 15:12'!
context: anObject
	"Set the value of context"

	context := anObject! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'mb 2/6/2006 10:09'!
dateInput
	^ self brush: WADateInput new! !

!WARenderCanvas methodsFor: 'accessing' stamp: 'avi 6/13/2004 01:08'!
document
	^ self context document! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'avi 6/8/2005 21:49'!
fileUpload
	^ self brush: WAFileUploadTag new	! !

!WARenderCanvas methodsFor: 'form-buttons' stamp: 'avi 1/9/2006 21:52'!
form
	^ self brush: WAFormTag new! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'lr 9/23/2005 18:09'!
hiddenInput
	^ self brush: WAHiddenInputTag new.! !

!WARenderCanvas methodsFor: 'form-buttons' stamp: 'chc 9/17/2010 13:51'!
ifPost: aBlock
	"If it is a POST we run the block.
	Better to use #ifPressed: on the submit button." 

	^self isPost ifTrue:[aBlock value]! !

!WARenderCanvas methodsFor: 'form-buttons' stamp: 'lr 9/14/2005 22:01'!
imageButton
	^ self brush: WAImageButtonTag new.! !

!WARenderCanvas methodsFor: 'initialize-release' stamp: 'avi 6/13/2004 01:01'!
initializeWithContext: aRenderingContext callbacks: aCallbackStore
	context _ aRenderingContext.
	callbacks _ aCallbackStore! !

!WARenderCanvas methodsFor: 'form-buttons' stamp: 'chc 9/17/2010 13:42'!
isPost
	"Is it a POST?"

	^context request isPostRequest! !

!WARenderCanvas methodsFor: '*greenneon-javascript' stamp: 'chc 4/12/2012 14:19'!
jFunction
	^JSFunction new! !

!WARenderCanvas methodsFor: '*greenneon-javascript' stamp: 'chc 4/12/2012 14:18'!
jScript
	^JSScript new! !

!WARenderCanvas methodsFor: '*greenneon-javascript' stamp: 'chc 4/12/2012 14:14'!
javascript
	^JSScript new! !

!WARenderCanvas methodsFor: 'form-buttons' stamp: 'chc 9/17/2010 15:27'!
nameField: aString

	^context request postFields at: aString! !

!WARenderCanvas methodsFor: 'public api' stamp: 'lr 3/28/2006 20:16'!
nextId
	^ 'id' , context advanceKey! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'ac 3/17/2005 17:13'!
option
	^ self brush: WAOptionTag new.! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'ac 3/17/2005 17:14'!
option: aBlock
	^ self option with: aBlock! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'lr 9/23/2005 18:09'!
passwordInput
	^ self brush: WAPasswordInputTag new.! !

!WARenderCanvas methodsFor: 'public api' stamp: 'mb 3/31/2006 11:38'!
peekNextId
	^ 'id' , context nextKey! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'ac 7/6/2005 10:45'!
radioButton
	^ self brush: WARadioButtonTag new.! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'ac 7/6/2005 10:46'!
radioButton: aBlock
	^ self radioButton with: aBlock! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'ac 7/6/2005 11:29'!
radioGroup
	^ WARadioGroup canvas: self! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'ac 7/6/2005 10:44'!
radioGroup: aBlock
	^ aBlock value: self radioGroup! !

!WARenderCanvas methodsFor: 'public api' stamp: 'avi 6/24/2004 14:00'!
render: anObject
	self flush.
	anObject renderOn: self! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'ac 3/17/2005 17:15'!
select
	^ self brush: WASelectTag new	! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'chc 10/21/2011 10:35'!
select: aBlock
	self select with: aBlock! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'ac 3/22/2005 17:50'!
textArea
	^ self brush: WATextAreaTag new! !

!WARenderCanvas methodsFor: 'form-elements' stamp: 'mb 2/6/2006 10:10'!
timeInput
	^ self brush: WATimeInput new! !

!WARenderCanvas methodsFor: 'accessing' stamp: 'chc 9/4/2010 15:12'!
view
	"Answer the value of view"

	^ view! !

!WARenderCanvas methodsFor: 'accessing' stamp: 'chc 9/4/2010 15:12'!
view: anObject
	"Set the value of view"

	view := anObject! !

Object subclass: #WAHtmlAttributes
	instanceVariableNames: 'attributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-Head'!

!WAHtmlAttributes commentStamp: 'chc 10/23/2011 11:12' prior: 0!
This class supports the addtion of attributes to a tag. 

!

!WAHtmlAttributes methodsFor: 'convenience' stamp: 'lr 9/30/2005 19:17'!
addClass: aString
	aString ifNotNil: [ self at: 'class' append: aString ].! !

!WAHtmlAttributes methodsFor: 'private' stamp: 'mb 5/20/2006 10:05'!
addMeasurementStyle: aString withValue: aValue
	| styleValue |
	"Default measurement is px"
	styleValue _ aValue isNumber ifTrue:
		[aValue px]
	ifFalse:
		[aValue displayString].
	self addStyle: aString , ': ' , styleValue.

! !

!WAHtmlAttributes methodsFor: 'convenience' stamp: 'lr 8/3/2006 13:20'!
addScript: aString
	aString ifNotNil: [ self at: 'script' append: aString separator: ';' ].! !

!WAHtmlAttributes methodsFor: 'convenience' stamp: 'lr 8/3/2006 13:20'!
addStyle: aString
	aString ifNotNil: [ self at: 'style' append: aString separator: ';' ].! !

!WAHtmlAttributes methodsFor: 'deprecated' stamp: 'mb 2/9/2006 18:15'!
align
	"Deprecated in XHTML"
	self deprecated.
! !

!WAHtmlAttributes methodsFor: 'deprecated' stamp: 'mb 2/9/2006 18:15'!
align: aValue
	"Deprecated in XHTML"
	self deprecated.
! !

!WAHtmlAttributes methodsFor: 'deprecated' stamp: 'mb 2/9/2006 18:13'!
alignBottom
	"Deprecated in XHTML"
	self deprecated.
	self at: 'valign' put: 'bottom'! !

!WAHtmlAttributes methodsFor: 'deprecated' stamp: 'mb 2/9/2006 18:22'!
alignCenter
	"Deprecated in XHTML, substitute a style"
	self addStyle: 'text-align: center'! !

!WAHtmlAttributes methodsFor: 'private' stamp: 'avi 6/22/2005 01:55'!
associations
	^ self attributes associations! !

!WAHtmlAttributes methodsFor: 'accessing' stamp: 'avi 9/10/2005 16:02'!
at: keyString
	^ (self at: keyString ifAbsent: [keyString -> nil]) value! !

!WAHtmlAttributes methodsFor: 'accessing' stamp: 'ac 9/25/2005 18:11'!
at: keyString append: aString
	^ self at: keyString append: aString separator: ' '! !

!WAHtmlAttributes methodsFor: 'accessing' stamp: 'mb 3/16/2006 23:48'!
at: keyString append: aString separator: separatorString
	aString ifNil: [^ self at: keyString].
	^ self at: keyString put: 
		(String streamContents:
			[:stream |
			self at: keyString ifPresent: 
				[:s | stream nextPutAll: s; nextPutAll: separatorString].
			stream nextPutAll: aString displayString])! !

!WAHtmlAttributes methodsFor: 'accessing' stamp: 'ac 3/16/2005 11:49'!
at: keyString ifAbsent: aBlock
	^ self associations
		detect: [:ea | ea key = keyString]
		ifNone: aBlock! !

!WAHtmlAttributes methodsFor: 'accessing' stamp: 'mb 3/16/2006 23:55'!
at: keyString ifAbsentPut: errBlock
	"What if errBlock evaluates to nil ?"
	^ self at: keyString ifAbsent: [self attributes add: keyString -> errBlock value]! !

!WAHtmlAttributes methodsFor: 'accessing' stamp: 'ac 9/25/2005 17:50'!
at: keyString ifPresent: aBlock
	^ aBlock value: (self at: keyString ifAbsent: [^ nil]) value! !

!WAHtmlAttributes methodsFor: 'accessing' stamp: 'mb 3/16/2006 23:47'!
at: keyString put: valueString
	valueString ifNotNil: [self attributes at: keyString put: valueString]! !

!WAHtmlAttributes methodsFor: 'private' stamp: 'avi 6/22/2005 01:49'!
attributes
	^ attributes ifNil: [attributes _ Dictionary new]! !

!WAHtmlAttributes methodsFor: 'deprecated' stamp: 'mb 2/9/2006 18:22'!
background: aValue
	"Deprecated in XHTML, substitute a style"
	self addStyle: 'background-image: url(' , aValue displayString , ')'.
! !

!WAHtmlAttributes methodsFor: 'deprecated' stamp: 'mb 2/9/2006 18:23'!
backgroundColor: aValue
	"Deprecated in XHTML, substitute a style"
	self addStyle: 'background-color: ' , aValue displayString.
! !

!WAHtmlAttributes methodsFor: 'deprecated' stamp: 'mb 2/9/2006 18:16'!
bgcolor
	"Deprecated in XHTML"
	self deprecated.
! !

!WAHtmlAttributes methodsFor: 'deprecated' stamp: 'mb 2/9/2006 18:16'!
bgcolor: aValue
	"Deprecated in XHTML"
	self deprecated.
! !

!WAHtmlAttributes methodsFor: 'deprecated' stamp: 'mb 2/9/2006 18:26'!
border: aValue
	"Deprecated in XHTML, substitute a style"
	| cssValue |
	cssValue _ 'none'.
	aValue displayString = '1' ifTrue: [cssValue := 'solid 1px black'].
	aValue displayString = '2' ifTrue: [cssValue := 'solid 2px black'].
	self addStyle: 'border: ' , cssValue.
! !

!WAHtmlAttributes methodsFor: 'dnu' stamp: 'ab 5/24/2003 00:42'!
doesNotUnderstand: aMessage
	| argCount |
	argCount _ aMessage arguments size.
	argCount = 0 ifTrue: [^ self at: aMessage selector put: true].
	argCount = 1 ifTrue: [^ self at: aMessage selector allButLast put: aMessage argument].
	^ super doesNotUnderstand: aMessage! !

!WAHtmlAttributes methodsFor: 'deprecated' stamp: 'mb 4/3/2006 15:56'!
height: aValue
	"Deprecated in XHTML, substitute a style"
	self addMeasurementStyle: 'height' withValue: aValue
! !

!WAHtmlAttributes methodsFor: 'deprecated' stamp: 'mb 2/9/2006 18:28'!
noBorder
	"Deprecated in XHTML, substitute a style"
	self border: 0.! !

!WAHtmlAttributes methodsFor: 'copying' stamp: 'lr 11/8/2005 21:58'!
postCopy
	super postCopy.
	attributes := attributes copy.! !

!WAHtmlAttributes methodsFor: 'javascript' stamp: 'avi 3/12/2004 17:25'!
submitOnChange
	self at: 'onChange' put: 'submit()'! !

!WAHtmlAttributes methodsFor: 'javascript' stamp: 'avi 2/7/2004 02:18'!
submitOnClick
	self at: 'onClick' put: 'submit()'! !

!WAHtmlAttributes methodsFor: 'deprecated' stamp: 'mb 4/3/2006 15:56'!
width: aValue
	"Deprecated in XHTML, substitute a style"
	"((( WAHtmlAttributes new width: 12; height: 28; border: 1 )))"
	self addMeasurementStyle: 'width' withValue: aValue
! !

!WAHtmlAttributes methodsFor: 'printing' stamp: 'chc 2/24/2011 13:46'!
writeKey: aKey value: aValue on: aStream
	aValue = false ifFalse: [
		aStream nextPut: $ ; nextPutAll: aKey; nextPutAll: '="'.
		aValue = true
			ifFalse: [ GNHtmlEncoder encode: aValue to: aStream ]
			ifTrue: [ aStream nextPutAll: aKey ].
		aStream nextPut: $" ]! !

!WAHtmlAttributes methodsFor: 'printing' stamp: 'lr 6/14/2006 08:17'!
writeOn: aStream
	attributes ifNil: [ ^ self ].
	attributes keysAndValuesDo: [ :key :value |
		self 
			writeKey: key asLowercase 
			value: value on: aStream ]! !

Object subclass: #WAHtmlDocument
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-Document'!

!WAHtmlDocument commentStamp: 'chc 10/23/2011 12:12' prior: 0!
This class is the superclass to WAHtmlStreamDocument. This class ensures the head matter of an html page is looked after. In the #root instance variable is an instance of WAHtmlRoot, which builds the head of a page. The subclass is where the head and body (which is created in #default methods ) are sent out over th wire. !

!WAHtmlDocument class methodsFor: 'instance creation' stamp: 'mb 3/30/2006 12:32'!
new
	^ self root: self newRoot! !

!WAHtmlDocument class methodsFor: 'instance creation' stamp: 'mb 3/30/2006 12:32'!
newRoot
	^ self rootClass new! !

!WAHtmlDocument class methodsFor: 'instance creation' stamp: 'avi 6/18/2004 18:22'!
root: anHtmlRoot
	^ self basicNew initializeWithRoot: anHtmlRoot! !

!WAHtmlDocument class methodsFor: 'instance creation' stamp: 'mb 3/30/2006 12:27'!
rootClass
	^ WAHtmlRoot! !

!WAHtmlDocument methodsFor: 'as yet unclassified' stamp: 'avi 7/8/2004 00:02'!
close! !

!WAHtmlDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 13:29'!
closeTag: aString
	self subclassResponsibility! !

!WAHtmlDocument methodsFor: 'as yet unclassified' stamp: 'avi 6/19/2004 18:04'!
initializeWithRoot: aRoot
	root _ aRoot! !

!WAHtmlDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 13:28'!
openTag: aString attributes: anAttributes
	self subclassResponsibility! !

!WAHtmlDocument methodsFor: 'as yet unclassified' stamp: 'avi 6/18/2004 18:24'!
root
	^ root! !

!WAHtmlDocument methodsFor: 'as yet unclassified' stamp: 'mb 3/3/2006 12:21'!
shouldPrintCloseTagFor: aString
	^(#('hr' 'br' 'input' 'img' 'link') includes: aString asString) not! !

!WAHtmlDocument methodsFor: 'as yet unclassified' stamp: 'pmm 4/19/2006 17:44'!
text: aString
	self subclassResponsibility ! !

WAHtmlDocument subclass: #WAHtmlStreamDocument
	instanceVariableNames: 'state stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-Document'!

!WAHtmlStreamDocument methodsFor: 'as yet unclassified' stamp: 'avi 7/8/2004 00:40'!
bodyStream
	state = #head ifTrue:
		[state _ #body.
		root writeOn: stream].
	^ stream! !

!WAHtmlStreamDocument methodsFor: 'as yet unclassified' stamp: 'avi 7/8/2004 00:41'!
close
	self bodyStream nextPutAll: '</body></html>'! !

!WAHtmlStreamDocument methodsFor: 'as yet unclassified' stamp: 'avi 7/8/2004 00:39'!
closeTag: aString
	self writeCloseTag: aString on: self bodyStream! !

!WAHtmlStreamDocument methodsFor: 'as yet unclassified' stamp: 'avi 7/8/2004 00:38'!
initializeWithRoot: anHtmlRoot
	super initializeWithRoot: anHtmlRoot.
	stream _ String new writeStream.
	state _ #head! !

!WAHtmlStreamDocument methodsFor: 'as yet unclassified' stamp: 'avi 7/8/2004 00:39'!
openTag: aString attributes: anAttributes
	self writeOpenTag: aString attributes: anAttributes on: self bodyStream! !

!WAHtmlStreamDocument methodsFor: 'as yet unclassified' stamp: 'avi 7/8/2004 00:39'!
stream
	^ stream! !

!WAHtmlStreamDocument methodsFor: 'as yet unclassified' stamp: 'avi 7/8/2004 00:38'!
stream: aStream
	stream _ aStream! !

!WAHtmlStreamDocument methodsFor: 'as yet unclassified' stamp: 'mb 3/13/2006 15:48'!
text: aString
	self bodyStream nextPutAll: aString displayString! !

!WAHtmlStreamDocument methodsFor: 'as yet unclassified' stamp: 'avi 5/18/2004 13:52'!
writeCloseTag: aString on: aStream
	(self shouldPrintCloseTagFor: aString)
		ifTrue: [aStream nextPutAll: '</'; nextPutAll: aString; nextPut: $>]! !

!WAHtmlStreamDocument methodsFor: 'as yet unclassified' stamp: 'avi 6/13/2004 01:04'!
writeOpenTag: aString attributes: anAttributes on: aStream
	aStream
		nextPut: $<;
		nextPutAll: aString.
	anAttributes ifNotNil: [anAttributes writeOn: aStream].
	(self shouldPrintCloseTagFor: aString) ifFalse: [aStream nextPutAll: ' /'].
	aStream nextPut: $>! !

Object subclass: #WAHtmlElement
	instanceVariableNames: 'children name attributes isClosed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-Head'!

!WAHtmlElement commentStamp: 'chc 10/23/2011 11:14' prior: 0!
This class helps to add CSS or JavaScript to a page either in the head section or an external file.!

!WAHtmlElement class methodsFor: 'as yet unclassified' stamp: 'ab 5/12/2003 11:17'!
named: aString
	^ self named: aString attributes: (WAHtmlAttributes new)! !

!WAHtmlElement class methodsFor: 'as yet unclassified' stamp: 'ab 5/12/2003 11:17'!
named: aString attributes: anAttributes
	^ self new initializeWithName: aString attributes: anAttributes! !

!WAHtmlElement methodsFor: 'commands' stamp: 'ab 1/11/2003 13:47'!
add: anElement
	children ifNil: [children _ OrderedCollection new].
	children add: anElement.! !

!WAHtmlElement methodsFor: 'accessing' stamp: 'rjl 8/4/2006 11:36'!
attributeAt: aString
    ^attributes at: aString! !

!WAHtmlElement methodsFor: 'accessing' stamp: 'ab 5/12/2003 11:14'!
attributeAt: aString put: anObject
	attributes at: aString put: anObject! !

!WAHtmlElement methodsFor: 'accessing' stamp: 'avi 5/18/2004 13:49'!
beClosed
	isClosed _ true! !

!WAHtmlElement methodsFor: 'commands' stamp: 'ab 3/29/2003 00:10'!
childrenDo: aBlock
	children ifNotNil: [children do: aBlock]! !

!WAHtmlElement methodsFor: 'initialize-release' stamp: 'avi 5/18/2004 13:49'!
initializeWithName: aString attributes: anAttributes
	name _ aString.
	attributes _ anAttributes.
	isClosed _ true.! !

!WAHtmlElement methodsFor: 'accessing' stamp: 'JF 6/11/2003 14:47'!
name
	^ name asLowercase! !

!WAHtmlElement methodsFor: 'accessing' stamp: 'avi 5/18/2004 13:50'!
notClosed
	isClosed _ false! !

!WAHtmlElement methodsFor: 'printing' stamp: 'JF 6/11/2003 14:44'!
printCloseTagOn: aStream 
	aStream
		nextPutAll: '</';
		nextPutAll: self name;
		nextPut: $>! !

!WAHtmlElement methodsFor: 'printing' stamp: 'avi 5/22/2004 15:17'!
printHtmlOn: aStream
	self printOpenTagOn: aStream.
	self childrenDo: [:ea | ea writeOn: aStream].
	self shouldPrintCloseTag ifTrue: [self printCloseTagOn: aStream].! !

!WAHtmlElement methodsFor: 'printing' stamp: 'avi 6/19/2004 18:07'!
printOpenTagOn: aStream 
	aStream
		nextPut: $<;
		nextPutAll: self name.
	attributes ifNotNil: [attributes writeOn: aStream].
	self shouldPrintCloseTag ifFalse: [aStream nextPutAll: ' /'].
	aStream nextPut: $>! !

!WAHtmlElement methodsFor: 'accessing' stamp: 'avi 5/18/2004 13:51'!
shouldPrintCloseTag
	^ isClosed! !

!WAHtmlElement methodsFor: 'commands' stamp: 'avi 6/19/2004 18:10'!
writeOn: aStream
	self printOpenTagOn: aStream.
	self childrenDo: [:ea | ea isString ifTrue: [aStream nextPutAll: ea] ifFalse: [ea writeOn: aStream]].
	self shouldPrintCloseTag ifTrue: [self printCloseTagOn: aStream].! !

Object subclass: #WAHtmlRoot
	instanceVariableNames: 'docType title htmlAttrs headAttrs bodyAttrs headElements scripts styles resourceBaseUrl'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-Head'!

!WAHtmlRoot commentStamp: 'chc 10/23/2011 12:01' prior: 0!
In each selector that produces a page will be:
	
	c := self canvas.
	c buildHead.
		self header.
		self linksbar.
		
	
The second line will create an instance of WAHtmlRoot for that page. This creates the head section of the Html page. In Seaside this is done for you, but here it's explicit. I was always confused in Seaside about how the head of the web page was created. 

WARendeCanvas>>#buildHead

	(view respondsTo: #title) ifTrue: [ context document root title: view title. ].
	(view respondsTo: #style) ifTrue: [ context document root addStyle: view style].
	(view respondsTo: #script) ifTrue: [ context document root addScript: view script].
	
	((context request isPostRequest) and: [view respondsTo: #processForm]) ifTrue: [ view processForm ].
	"context document root linkToStyle: 'http://smalltalktelevision.com/resources/start.css'."
	
The selectors #title, #style, and #script are checked for here. The selectors of those names in SMBaseView are identified and acted upon here. If a class has a form then this method checks for #processForm and acts on it. (If this method detected more than one kind of form, then there could be more than one kind of form in a class.) 

JavaScript and CSS can be in the image or outside the image in their own file. This image only treates those that are in the image. But if you wanted to have external files, then you'd use #linkToStyle: (as in the class comment here) or #linkToScript:. This class WAHtmlRoot is full of tools for changing pieces of the head section of a web page. !

!WAHtmlRoot class methodsFor: 'as yet unclassified' stamp: 'avi 6/19/2004 18:05'!
new
	^ self basicNew initialize! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: 'avi 9/11/2005 14:39'!
absoluteUrlForResource: aString
	(aString beginsWith: 'http') ifTrue: [^ aString].
	resourceBaseUrl ifNil: [^ aString].
	^ resourceBaseUrl, aString! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: 'avi 6/18/2004 17:01'!
addHeadElement: anHtmlElement
	headElements add: anHtmlElement! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: 'mb 2/9/2006 18:45'!
addHtmlNameSpace
	htmlAttrs
		at: 'xmlns' put: 'http://www.w3.org/1999/xhtml';
		at: 'xml:lang' put: 'en';
		at: 'lang' put: 'en'.
! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: 'mb 6/14/2006 13:03'!
addMetaContentType
	self addHeadElement:
		((WAHtmlElement named: 'meta')
				attributeAt: 'http-equiv' put: 'Content-Type';
				attributeAt: 'content'  put: self contentType , '; charset=' , self charSet;
				notClosed;
				yourself).
! !

!WAHtmlRoot methodsFor: 'javascript' stamp: 'avi 6/18/2004 17:02'!
addScript: aString
	(scripts includes: aString) ifFalse: [scripts add: aString]! !

!WAHtmlRoot methodsFor: 'css' stamp: 'avi 6/18/2004 17:02'!
addStyle: aString
	(styles includes: aString) ifFalse: [styles add: aString]! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: 'avi 6/17/2004 15:56'!
bodyAttributes
	^ bodyAttrs! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: 'mb 2/9/2006 18:48'!
charSet
	^'utf-8'! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: 'avi 9/11/2005 14:09'!
contentBase: urlString
	self addHeadElement:
		((WAHtmlElement named: 'base')
				attributeAt: 'href' put: urlString;
				yourself)! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: 'mb 3/30/2006 12:28'!
contentType
	^'text/html'! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: 'avi 6/17/2004 15:53'!
docType
	^ docType! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: 'avi 6/17/2004 15:53'!
docType: aString
	docType _ aString! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: 'avi 11/1/2005 09:07'!
forIE5Do: aBlock
	self addHeadElement: (WAConditionalComment new start: 'if gte IE 5').
	aBlock value.
	self addHeadElement: (WAConditionalComment new end: 'endif').! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: 'gk 1/9/2006 17:28'!
forIE6Do: aBlock
	self addHeadElement: (WAConditionalComment new start: 'if IE 6').
	aBlock value.
	self addHeadElement: (WAConditionalComment new end: 'endif').! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: 'avi 6/17/2004 15:57'!
headAttributes
	^ headAttrs! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: 'avi 6/17/2004 15:54'!
htmlAttributes
	^ htmlAttrs! !

!WAHtmlRoot methodsFor: 'initialize-release' stamp: 'mb 2/10/2006 11:26'!
initialize
	htmlAttrs _ WAHtmlAttributes new.
	headAttrs _ WAHtmlAttributes new.
	bodyAttrs _ WAHtmlAttributes new.
	headElements _ OrderedCollection new.
	scripts _ OrderedCollection new.
	styles _ OrderedCollection new.
	docType _ '<!!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">'.
	title _ 'Seaside'.

	self addHtmlNameSpace.
	self addMetaContentType.! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: 'rjl 8/4/2006 11:40'!
linkToScript: url 
	"only link to script if it's not already been linked too, necessary when lists of child components try to link to dependant scripts, a google map for example"

	| fullUrl |
	fullUrl := self absoluteUrlForResource: url asString.
	headElements 
		detect: [:each | each name = 'script' and: [(each attributeAt: #src) = fullUrl]]
		ifNone: [self addHeadElement: (self scriptElementWithSrc: fullUrl)]! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: 'mb 6/14/2006 13:16'!
linkToStyle: url
	self addHeadElement:
		(self styleElementWithHref: (self absoluteUrlForResource: url asString))
! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: 'mb 6/14/2006 12:38'!
redirectTo: locationString delay: aNumber
	self addHeadElement:
		((WAHtmlElement named: 'meta')
				attributeAt: 'http-equiv' put: 'refresh';
				attributeAt: 'content' put: aNumber displayString , ';URL=' , locationString;
				yourself).
! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: 'avi 9/11/2005 14:39'!
resourceBaseUrl
	^ resourceBaseUrl! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: 'avi 9/11/2005 14:38'!
resourceBaseUrl: aString
	resourceBaseUrl _ aString! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: 'mb 6/18/2006 19:32'!
scriptElementWithSrc: aString
	^(WAHtmlElement named: 'script')
			attributeAt: 'src' put: aString;
			attributeAt: 'type' put: 'text/javascript';
			yourself! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: 'mb 6/14/2006 13:15'!
styleElementWithHref: aString
	^(WAHtmlElement named: 'link')
			attributeAt: 'href' put: aString;
			attributeAt: 'rel' put: 'stylesheet';
			attributeAt: 'type' put: 'text/css';
			notClosed;
			yourself
! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: 'avi 6/17/2004 15:53'!
title
	^ title! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: 'avi 6/17/2004 15:54'!
title: aString
	title _ aString! !

!WAHtmlRoot methodsFor: 'as yet unclassified' stamp: 'chc 10/6/2011 09:08'!
writeHeadOn: aStream
	aStream nextPutAll: '<title>', title, '</title>'.
	headElements do: [:ea | ea writeOn: aStream].
	styles do: [:ea | self writeStyle: ea on: aStream].
	scripts do: [:ea | self writeScript: ea on: aStream].
! !

!WAHtmlRoot methodsFor: 'writing' stamp: 'avi 7/5/2004 11:45'!
writeOn: aStream
	aStream nextPutAll: docType.
	aStream nextPutAll: '<html'.
	htmlAttrs writeOn: aStream.
	aStream nextPutAll: '><head'.
	headAttrs writeOn: aStream.
	aStream nextPutAll: '>'.
	self writeHeadOn: aStream. 
	aStream nextPutAll: '</head><body'.
	bodyAttrs writeOn: aStream.
	aStream nextPutAll: '>'.! !

!WAHtmlRoot methodsFor: 'writing' stamp: 'avi 1/22/2005 22:00'!
writeScript: aString on: aStream
	aStream
		nextPutAll: '<script type="text/javascript">';
		nextPutAll: aString;
		nextPutAll: '</script>'! !

!WAHtmlRoot methodsFor: 'writing' stamp: 'avi 6/18/2004 18:37'!
writeStyle: aString on: aStream
	aStream
		nextPutAll: '<style>';
		nextPutAll: aString;
		nextPutAll: '</style>'! !

Object subclass: #WARenderingContext
	instanceVariableNames: 'actionUrl count callbacks document mode request response properties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GreenNeon-Document'!

!WARenderingContext commentStamp: 'chc 10/23/2011 12:15' prior: 0!
In HVTransientView there is this method: 

HVTransientView class>>#canvasClass
	
	| context document  |
	
	document := WAHtmlStreamDocument new. 
	context := WARenderingContext new document: document.
	^WARenderCanvas context: context callbacks: nil.
	
It creates the container that we put the web page into, which is built by the: 

c _ self canvas.

at the beginning of every web page we create.

Seaside uses callbacks, which GreenNeon does not. That's why there is a nil after the #context:callbacks: selector. Seaside is very modular -- more modular than it's monolithic number of classes would suppose -- so, the callbacks, continuations, and canvas separate easily. All this to say, the instvars for callbacks have been left in this class and may be brought into GreenNeon as a separate class category called a Kit.
	



	

!

!WARenderingContext class methodsFor: 'instance creation' stamp: 'avi 3/25/2004 02:21'!
new
	^ self basicNew initialize! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ab 2/13/2003 01:25'!
actionUrl
	"Answer the value of actionUrl"

	^ actionUrl! !

!WARenderingContext methodsFor: 'accessing' stamp: 'avi 11/7/2005 13:13'!
actionUrl: anObject
	actionUrl _ anObject! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'avi 6/8/2004 00:42'!
advanceKey
	| key |
	key _ self nextKey.
	self increaseKey.
	^ key! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'lr 4/19/2006 08:05'!
callbackAt: aString
	^ callbacks at: aString ifAbsent: [ ]! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'avi 6/8/2004 02:01'!
callbackStreamForRequest: aRequest
	^ WACallbackStream callbacks: callbacks request: aRequest! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'avi 6/7/2004 22:17'!
callbacksFor: anObject
	^ WACallbackRegistry context: self owner: anObject! !

!WARenderingContext methodsFor: 'modes' stamp: 'avi 3/13/2004 22:19'!
clearMode
	mode _ nil! !

!WARenderingContext methodsFor: 'accessing' stamp: 'lr 3/27/2006 10:42'!
count
	^ count! !

!WARenderingContext methodsFor: 'accessing' stamp: 'lr 3/27/2006 10:42'!
count: anInteger
	count := anInteger! !

!WARenderingContext methodsFor: 'modes' stamp: 'avi 3/13/2004 22:19'!
debugMode
	mode _ #debug! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ab 2/13/2003 01:25'!
document
	"Answer the value of document"

	^ document! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ab 2/13/2003 01:25'!
document: anObject
	"Set the value of document"

	document _ anObject! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'mb 11/27/2005 19:22'!
increaseKey
	count contents: count contents + 1! !

!WARenderingContext methodsFor: 'initialize-release' stamp: 'mb 11/27/2005 19:22'!
initialize
	count _ ValueHolder new contents: 1.
	callbacks _ Dictionary new
! !

!WARenderingContext methodsFor: 'modes' stamp: 'avi 3/13/2004 22:20'!
isDebugMode
	^ mode = #debug! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'mb 3/9/2006 18:07'!
nextKey
	"See discussion on VWNC
	Some VW users have overriden #displayString to answer a Text object.
	#asString works fine here since the count held by the ValueHolder is a Number"
	^ count contents asString
! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ac 2/18/2006 17:33'!
properties
	^ properties ifNil: [properties _ Dictionary new]! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ac 2/18/2006 17:33'!
propertyAt: key ifAbsent: aBlock
	^ self properties at: key ifAbsent: aBlock! !

!WARenderingContext methodsFor: 'accessing' stamp: 'ac 2/18/2006 17:33'!
propertyAt: key put: value
	^ self properties at: key put: value! !

!WARenderingContext methodsFor: 'documents' stamp: 'avi 5/22/2004 18:52'!
registry
	^ WACurrentSession value application! !

!WARenderingContext methodsFor: 'accessing' stamp: 'avi 4/13/2004 21:43'!
request
	^ request! !

!WARenderingContext methodsFor: 'accessing' stamp: 'avi 4/13/2004 21:43'!
request: aRequest
	request _ aRequest! !

!WARenderingContext methodsFor: 'accessing' stamp: 'avi 5/18/2004 14:00'!
response
	^ response! !

!WARenderingContext methodsFor: 'accessing' stamp: 'avi 5/18/2004 14:00'!
response: aResponse
	response _ aResponse! !

!WARenderingContext methodsFor: 'callbacks' stamp: 'avi 9/2/2004 14:46'!
storeCallback: aCallback	
	| key |
	key _ self advanceKey.
	callbacks at: (aCallback convertKey: key) put: aCallback.
	^ key! !

!WARenderingContext methodsFor: 'documents' stamp: 'avi 5/22/2004 18:04'!
urlForDocument: anObject
	^ self urlForDocument: anObject mimeType: nil
! !

!WARenderingContext methodsFor: 'documents' stamp: 'avi 5/22/2004 18:02'!
urlForDocument: anObject mimeType: mimeString
	^ self urlForDocument: anObject mimeType: mimeString fileName: nil! !

!WARenderingContext methodsFor: 'documents' stamp: 'mbany 4/14/2005 12:14'!
urlForDocument: anObject mimeType: mimeType fileName: fileName
	^ (self registry urlForRequestHandler:
		(WADocumentHandler
			document: anObject
			mimeType: mimeType
			fileName: fileName)) displayString! !

!Stream methodsFor: '*greenneon-javascript' stamp: 'lr 5/10/2006 20:31'!
arguments: aCollection
	self nextPut: $(.
	aCollection
		do: [ :each | self javascript: each ]
		separatedBy: [ self nextPut: $, ].
	self nextPut: $)! !

!Stream methodsFor: '*greenneon-javascript' stamp: 'lr 4/11/2006 19:45'!
javascript: anObject
	anObject javascriptOn: self! !
GNHtmlEncoder initialize!
